We are correct:

@Override
public void updatePipeline(String clientName, ExtendedBlock oldBlock, ExtendedBlock newBlock, DatanodeID[] newNodes, String[] storageIDs) throws IOException {
    UpdatePipelineRequestProto req = UpdatePipelineRequestProto.newBuilder()
        .setClientName(clientName).setOldBlock(PBHelper.convert(oldBlock))
    	.setNewBlock(PBHelper.convert(newBlock)).addAllNewNodes(Arrays.asList(PBHelper.convert(newNodes)))
    	.addAllStorageIDs(storageIDs == null ? null :  !!! Arrays.asList(storageIDs) !!! ).build();
    try {
        rpcProxy.updatePipeline(null, req);
    } catch (ServiceException e) {
        throw ProtobufHelper.getRemoteException(e);
    }
}

Truth:	  arrays . as _ list ( storage _ i _ ds )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/ClientNamenodeProtocolTranslatorPB.java :881
true_ref: Cal(Nm(arrays),Nm(as,list),Nm(storage,i,ds)) predicted at: 2, tree predicted at: 2
environment UNKs: ['ds', 'req', 'pb', 'pipeline', 'proto', 'datanode', 'extended', 'rpc', 'protobuf', 'add,all,storage,i,ds', 'storage,i,ds', 'add,all,new,nodes', 'set,new,block', 'as,list', 'new,nodes', 'pb,helper', 'update,pipeline,request,proto', 'new,block', 'set,old,block', 'client,name', 'old,block', 'set,client,name', 'new,builder', 'update,pipeline', 'io,exception', 'datanode,id', 'extended,block', 'service,exception', 'rpc,proxy', 'protobuf,helper', 'get,remote,exception']
Known subtokens to predict: ['arrays'], UNK-available: ['storage,i,ds', 'as,list'], UNK-unavailable: []
hyps:
	(0.139): ArAc(Nm(storage,i,ds),IntEx(0))
	(0.036): Cal(Nm(arrays),Nm(as,list),Nm(storage,i,ds))
	(0.026): Cal(Nm(storage,i,ds),Nm(convert,to),Nm(storage,i,ds))
	(0.024): Cal(Nm(storage,i,ds),Nm(convert,to,string),Nm(storage,i,ds))
	(0.007): Cal(Nm(storage,i,ds),Nm(convert,to),Nm(storage,i,ds),Nm(storage,i,ds))

seq2seq:
	storage _ i _ ds . to _ <unk> _ case ( )
	storage _ i _ ds . clone ( )
	storage _ i _ ds . get _ bytes ( )
	pb _ helper . convert ( storage _ i _ ds )
	storage _ i _ ds . to _ bytes _ array ( )


seq2tree:
	Cal ( Nm ( storage , i , ds ) , Nm ( convert ) , Nm ( new , nodes ) )
	Cal ( Nm ( storage , i , ds ) , Nm ( convert ) , Nm ( new , block ) )
	Cal ( Nm ( storage , i , ds ) , Nm ( convert ) , Nm ( storage , i , ds ) )
	Cal ( Nm ( storage , i , ds ) , Nm ( convert ) , Nm ( storage , i ) )
	Cal ( Nm ( storage , i , ds ) , Nm ( convert ) , Nm ( storage , i , ds ) , Nm ( storage , i , ds ) )


------------------------------------------------------------------------------------

@Override
public synchronized void setInput(byte[] b, int off, int len) {
    if (b == null) {
        throw new NullPointerException();
    }
    if (off < 0 ||  !!! len < 0 !!!  || off > b.length - len) {
        throw new ArrayIndexOutOfBoundsException();
    }
    finished = false;
    if (len > uncompressedDirectBuf.remaining()) {
        //
        this.userBuf = b;
        this.userBufOff = off;
        this.userBufLen = len;
    } else {
        ((ByteBuffer) uncompressedDirectBuf).put(b, off, len);
        uncompressedDirectBufLen = uncompressedDirectBuf.position();
    }
    bytesRead += len;
}

Truth:	  len < 0
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/SnappyCompressor.java :107
true_ref: Ls(Nm(len),IntEx(0)) predicted at: 1, tree predicted at: 1
environment UNKs: ['off', 'finished', 'remaining', 'uncompressed', 'direct', 'set,input', 'bytes,read', 'array,index,out,of,bounds,exception', 'uncompressed,direct,buf', 'uncompressed,direct,buf,len', 'null,pointer,exception', 'user,buf', 'user,buf,off', 'user,buf,len', 'byte,buffer']
Known subtokens to predict: ['len', '0'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.372): Ls(Nm(len),IntEx(0))
	(0.279): Gt(Nm(len),Fld(Nm(b),Nm(length)))
	(0.043): Gt(Fld(Nm(b),Nm(length)),Nm(len))
	(0.033): Gt(Nm(len),Nm(off))
	(0.018): Gt(Nm(len),Nm(finished))

seq2seq:
	off < 0
	len < 0		(CORRECT!)
	b == null
	off < b . length
	bytes _ read < 0

seq2tree:
	Ls ( Nm ( off ) , IntEx ( 0 ) )
	Ls ( Nm ( len ) , IntEx ( 0 ) )		(CORRECT!)
	Ls ( IntEx ( 0 ) , Nm ( off ) )
	Ls ( Nm ( off ) , Fld ( Nm ( b ) , Nm ( length ) ) )
	Ls ( IntEx ( 0 ) , Nm ( len ) )

------------------------------------------------------------------------------------

private static String getNameServiceId(Configuration conf, String addressKey) {
    String nameserviceId = conf.get(DFS_NAMESERVICE_ID);
    if (nameserviceId != null) {
        return nameserviceId;
    }
    Collection<String> nsIds = getNameServiceIds(conf);
    if (1 ==  !!! nsIds.size() !!! ) {
        return nsIds.toArray(new String[1])[0];
    }
    String nnId = conf.get(DFS_HA_NAMENODE_ID_KEY);
    return getSuffixIDs(conf, addressKey, null, nnId, LOCAL_ADDRESS_MATCHER)[0];
}

Truth:	  ns _ ids . size ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/DFSUtil.java :1257
true_ref: Cal(Nm(ns,ids),Nm(size)) predicted at: 1, tree predicted at: 1
environment UNKs: ['nameservice', 'conf', 'ds', 'nn', 'ns', 'dfs', 'ha', 'namenode', 'get,name,service,id', 'nameservice,id', 'address,key', 'get,suffix,i,ds', 'nn,id', 'local,address,matcher', 'ns,ids', 'to,array', 'dfs,nameservice,id', 'dfs,ha,namenode,id,key', 'get,name,service,ids']
Known subtokens to predict: ['size'], UNK-available: ['ns,ids'], UNK-unavailable: []
hyps:
	(0.820): Cal(Nm(ns,ids),Nm(size))
	(0.025): Cal(Nm(conf),Nm(size))
	(0.009): Enc(Mod(Cal(Nm(ns,ids),Nm(size)),IntEx(2)))
	(0.004): Cal(Nm(address,key),Nm(size))
	(0.003): Cal(Nm(address,key),Nm(length))

seq2seq:
	- 1
	integer . max _ value
	conf . size ( )
	conf _ ids . size ( )
	long . max _ value

seq2tree:
	ds ( IntEx ( 1 ) )
	Cal ( Nm ( ns , ids ) , Nm ( size ) )		(CORRECT!)
	Fld ( Nm ( string , pool ) , Nm ( blank ) )
	Fld ( Nm ( string , pool ) , Nm ( null ) )
	Cal ( Nm ( conf , ids ) , Nm ( size ) )

------------------------------------------------------------------------------------

@Override
protected void checkRpcAdminAccess() throws 
    IOException, AccessControlException {
  UserGroupInformation ugi = 
    UserGroupInformation.getCurrentUser();
  UserGroupInformation zkfcUgi = 
    UserGroupInformation.getLoginUser();
  if (adminAcl.isUserAllowed(ugi) || 
    ugi.getShortUserName()
    .equals(zkfcUgi.getShortUserName())) {
      LOG.info("Allowed RPC access from " + ugi 
      + " at " + Server.getRemoteAddress());
      return;
    }
  String msg = "Disallowed RPC access from " + ugi 
    + " at " + Server.getRemoteAddress() 
    + ". Not listed in " + DFSConfigKeys.DFS_ADMIN;
  LOG.warn(msg);
  throw new AccessControlException(msg);
}

Truth:	  zkfc _ ugi . get _ short _ user _ name ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/DFSZKFailoverController.java :188
true_ref: Cal(Nm(zkfc,ugi),Nm(get,short,user,name)) predicted at: 1, tree predicted at: 1
environment UNKs: ['ugi', 'admin', 'acl', 'rpc', 'information', 'zkfc', 'login', 'listed', 'dfs', 'disallowed', 'get,short,user,name', 'admin,acl', 'is,user,allowed', 'check,rpc,admin,access', 'access,control,exception', 'io,exception', 'user,group,information', 'zkfc,ugi', 'get,current,user', 'get,login,user', 'get,remote,address', '.,not,listed,in', 'dfs,admin', 'dfs,config,keys', 'allowed,rpc,access,from', 'disallowed,rpc,access,from']
Known subtokens to predict: [], UNK-available: ['zkfc,ugi', 'get,short,user,name'], UNK-unavailable: []
hyps:
	(0.305): Cal(Nm(zkfc,ugi),Nm(get,short,user,name))
	(0.063): Cal(Nm(zkfc,ugi),Nm(get,user,name))
	(0.006): Fld(Nm(user,type),Nm(rpc))
	(0.001): Fld(Fld(Nm(user,group,information),Nm(dfs,admin)),Nm(name))
	(0.001): Fld(Nm(user,type),Nm(application,rpc))

seq2seq:
	server . get _ user _ name ( )
	zkfc _ ugi . get _ user _ name ( )
	ugi _ ugi . get _ user _ name ( )
	user _ group _ information . get _ user _ name ( )
	dfs _ ugi . get _ user _ name ( )

seq2tree:
	Fld ( Nm ( dfs , config , keys ) , Nm ( dfs , admin ) )
	Cal ( Nm ( zkfc ) , Nm ( get , user , name ) )
	Cal ( Nm ( zkfc ) , Nm ( get , remote , address ) )
	Fld ( Nm ( dfs , config , keys ) , Nm ( dfs ) )
	Fld ( Nm ( dfs , config , keys ) , Nm ( dfs , <unk> ) )
------------------------------------------------------------------------------------

private static <E> void remove(final List<E> elements, final int i, final E expected) {
    final E removed = elements.remove( !!! -i - 1 !!! );
    Preconditions.checkState(removed == expected, "removed != expected=%s, removed=%s.", expected, removed);
}

Truth:	  - i - 1
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/Diff.java :142
true_ref: Minus(Neg(Nm(i)),IntEx(1)) predicted at: 3, tree predicted at: 3
environment UNKs: ['removed', 'preconditions', '!=', 'expecteds', 'removeds', 'check,state', 'removed,!=,expecteds,removeds']
Known subtokens to predict: ['1', 'i'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.308): Minus(Cal(Nm(elements),Nm(size)),IntEx(1))
	(0.292): Minus(Nm(i),IntEx(1))
	(0.057): Minus(Neg(Nm(i)),IntEx(1))
	(0.053): Plus(Nm(i),IntEx(1))
	(0.053): Minus(Neg(IntEx(1)),Nm(i))

seq2seq:
	elements . size ( ) - 1
	i + 1
	i - 1
	elements . size ( ) - i
	elements . get ( i )

seq2tree:
	Minus ( Nm ( i ) , IntEx ( 1 ) )
	Plus ( Nm ( i ) , IntEx ( 1 ) )
	!= ( Nm ( i ) )
	Cal ( Nm ( elements ) , Nm ( get ) , Nm ( i ) )
	Cal ( Nm ( elements ) , Nm ( key , set ) )
------------------------------------------------------------------------------------

private void handleTaskFinishedEvent(TaskFinishedEvent event) {
    TaskInfo taskInfo = info.tasksMap.get( !!! event.getTaskId() !!! );
    taskInfo.counters = event.getCounters();
    taskInfo.finishTime = event.getFinishTime();
    taskInfo.status = TaskStatus.State.SUCCEEDED.toString();
    taskInfo.successfulAttemptId = event.getSuccessfulTaskAttemptId();
}

Truth:	  event . get _ task _ id ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/JobHistoryParser.java :347
true_ref: Cal(Nm(event),Nm(get,task,id)) predicted at: 2, tree predicted at: 1
environment UNKs: ['finished', 'counters', 'successful', 'attempt', 'finish', 'succeeded', 'task,info', 'tasks,map', 'handle,task,finished,event', 'task,finished,event', 'get,counters', 'get,successful,task,attempt,id', 'finish,time', 'get,finish,time', 'to,string', 'successful,attempt,id', 'task,status']
Known subtokens to predict: ['task', 'event', 'id', 'get'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.197): Cal(Nm(event),Nm(get,id))
	(0.185): Cal(Nm(event),Nm(get,task,id))
	(0.069): Cal(Nm(event),Nm(get,type))
	(0.057): ClsEx(Cls(task,info))
	(0.020): Cal(Nm(event),Nm(get,task,name))

seq2seq:
	event . name
	event . type
	event . get _ id ( )
	event . id
	event . get _ key ( )

seq2tree:
	Cal ( Nm ( event ) , Nm ( get , id ) )
	Cal ( Nm ( event ) , Nm ( get , path ) )
	Cal ( Nm ( event ) , Nm ( get , description ) )
	Cal ( Nm ( event ) , Nm ( get , task , name ) )
	Cal ( Nm ( event ) , Nm ( get , task , name )

------------------------------------------------------------------------------------


private static boolean isNameResolved(InetAddress address) {
    String hostname =  !!! address.getHostName() !!! ;
    String ip = address.getHostAddress();
    return !hostname.equals(ip) || NetUtils.isLocalAddress(address);
}

Truth:	  address . get _ host _ name ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/DatanodeManager.java :1349
true_ref: Cal(Nm(address),Nm(get,host,name)) predicted at: 1, tree predicted at: 1
environment UNKs: ['hostname', 'ip', 'net', 'is,name,resolved', 'inet,address', 'net,utils', 'is,local,address', 'get,host,address']
Known subtokens to predict: ['name', 'host', 'address', 'get'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.080): Cal(Nm(address),Nm(get,host,name))
	(0.041): Cal(Nm(address),Nm(get,host))
	(0.037): Cal(Nm(address),Nm(get,host,address))
	(0.030): Cal(Nm(inet,address),Nm(get,hostname))
	(0.012): Cal(Cal(Nm(address),Nm(get,last,element)),Nm(get,value))

seq2seq:
	address . get _ host _ address ( )
	address . get _ port ( )
	address . get _ address ( )
	address . get _ parent _ address ( )
	address . get _ host _ address ( ) + <unk>

seq2tree:
	Cal ( Nm ( address ) , Nm ( get , host , address ) )
	Cal ( Nm ( address ) , Nm ( get , port ) )
	Cal ( Nm ( address ) , Nm ( get , address ) )
	Cal ( Nm ( address ) , Nm ( get , host , text ) )
	Cal ( Cal ( Nm ( address ) , Nm ( get , host , text ) ) , Nm ( trim ) )

------------------------------------------------------------------------------------

public void responseReceived(ResponseReceivedEvent event) {
    RequestResult result = event.getRequestResult();
    Date startDate = result.getStartDate();
    Date stopDate = result.getStopDate();
    long elapsed = stopDate.getTime() - startDate.getTime();
    synchronized (this) {
        this.lastE2Elatency = elapsed;
    }
    if ( !!! LOG.isDebugEnabled() !!! ) {
        int statusCode = result.getStatusCode();
        String etag = result.getEtag();
        HttpURLConnection urlConnection = (HttpURLConnection) event.getConnectionObject();
        int contentLength = urlConnection.getContentLength();
        String requestMethod = urlConnection.getRequestMethod();
        long threadId = Thread.currentThread().getId();
        LOG.debug(String.format("SelfThrottlingIntercept:: ResponseReceived: threadId=%d, Status=%d, Elapsed(ms)=%d, ETAG=%s, contentLength=%d, requestMethod=%s", threadId, statusCode, elapsed, etag, contentLength, requestMethod));
    }
}

Truth:	  log . is _ debug _ enabled ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/SelfThrottlingIntercept.java :105
true_ref: Cal(Nm(log),Nm(is,debug,enabled)) predicted at: 2, tree predicted at: 2
environment UNKs: ['received', 'elapsed', 'self', 'throttling', 'intercept', 'etag', 'elatency', 'response,received', 'response,received,event', 'http,url,connection', 'status,code', 'content,length', 'thread,id', 'request,method', 'stop,date', 'url,connection', 'self,throttling,intercept,response,received,thread,idd,statusd,elapsedmsd,etags,content,lengthd,request,methods', 'get,id', 'get,request,method', 'get,content,length', 'get,stop,date', 'get,status,code', 'get,etag', 'get,time', 'last,e,elatency', 'start,date', 'current,thread', 'get,connection,object']
Known subtokens to predict: ['enabled', 'is', 'log', 'debug'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.377): Neq(Nm(elapsed),Null(null))
	(0.140): Cal(Nm(log),Nm(is,debug,enabled))
	(0.046): Gt(Nm(elapsed),IntEx(0))
	(0.039): Neq(Nm(elapsed),IntEx(0))
	(0.007): Geq(Nm(elapsed),Nm(elatency))

seq2seq:
	result != null
	elapsed > 0
	result . get _ status _ code ( ) == workflow _ constants . status _ <unk>
	stop _ date . get _ time ( ) > 0
	result . get _ status _ code ( ) == status . status _ <unk>

seq2tree:
	InstanceOf ( Cal ( Nm ( event ) , Nm ( get , connection , object ) ) , Cls ( http , url , connection ) )
	Neq ( Nm ( start , date ) , Null ( null ) )
	Cal ( Nm ( log ) , Nm ( is , debug , enabled ) )		(CORRECT!)
	Neq ( Nm ( stop , date ) , Null ( null ) )
	threadid=%d ( Cal ( Nm ( result ) , Nm ( get , status , code ) ) , IntEx ( 0 ) )

------------------------------------------------------------------------------------

@Override
public synchronized String moveApplication(ApplicationId appId, String queueName) throws YarnException {
    SchedulerApplication<FSAppAttempt> app = applications.get(appId);
    if (app == null) {
        throw new YarnException("App to be moved " + appId + " not found.");
    }
    FSAppAttempt attempt = (FSAppAttempt) app.getCurrentAppAttempt();
    //
    synchronized (attempt) {
        FSLeafQueue oldQueue = (FSLeafQueue)  !!! app.getQueue() !!! ;
        FSLeafQueue targetQueue = queueMgr.getLeafQueue(queueName, false);
        if (targetQueue == null) {
            throw new YarnException("Target queue " + queueName + " not found or is not a leaf queue.");
        }
        if (targetQueue == oldQueue) {
            return oldQueue.getQueueName();
        }
        if (oldQueue.getRunnableAppSchedulables().contains(attempt)) {
            verifyMoveDoesNotViolateConstraints(attempt, oldQueue, targetQueue);
        }
        executeMove(app, attempt, oldQueue, targetQueue);
        return targetQueue.getQueueName();
    }
}

Truth:	  app . get _ queue ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/FairScheduler.java :1431
true_ref: Cal(Nm(app),Nm(get,queue)) predicted at: 2, tree predicted at: 1
environment UNKs: ['fs', 'attempt', 'schedulables', 'yarn', 'verify', 'does', 'violate', 'mgr', 'scheduler', 'applications', 'moved', 'fs,leaf,queue', 'old,queue', 'target,queue', 'get,queue,name', 'execute,move', 'get,runnable,app,schedulables', 'move,application', 'yarn,exception', 'application,id', 'queue,name', 'app,id', 'fs,app,attempt', 'verify,move,does,not,violate,constraints', 'queue,mgr', 'get,leaf,queue', 'scheduler,application', 'not,found,or,is,not,a,leaf,queue', 'get,current,app,attempt', 'not,found', 'app,to,be,moved']
Known subtokens to predict: ['queue', 'get', 'app'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.157): Cal(Nm(attempt),Nm(get,queue))
	(0.116): Cal(Nm(app),Nm(get,queue))
	(0.092): Cal(Nm(attempt),Nm(get),Nm(queue,name))
	(0.059): Cal(Nm(attempt),Nm(get),Nm(app,id))
	(0.009): StaticCall(Nm(get,queue))

seq2seq:
	attempt . clone ( )
	attempt . get _ leaf _ queue ( )
	attempt . get _ object ( )
	attempt . get _ object ( 0 )
	attempt . get _ <unk> _ queue ( )

seq2tree:
	Cal ( Nm ( attempt ) , Nm ( get , queue ) )
	Cal ( Nm ( app ) , Nm ( get , queue ) )		(CORRECT!)
	Cal ( Nm ( app ) , Nm ( get , meta , data ) )
	Cal ( Nm ( attempt ) , Nm ( lookup ) , Nm ( queue , name ) )
	Cal ( Nm ( attempt ) , Nm ( get , leaf , queue ) )
------------------------------------------------------------------------------------

@Override
public void transition(RMContainerImpl container, RMContainerEvent event) {
    //
    container.containerAllocationExpirer.unregister( !!! container.getContainerId() !!! );
    //
    container.eventHandler.handle(new RMNodeCleanContainerEvent(container.nodeId, container.containerId));
    //
    super.transition(container, event);
}

Truth:	  container . get _ container _ id ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/RMContainerImpl.java :535
true_ref: Cal(Nm(container),Nm(get,container,id)) predicted at: 3, tree predicted at: 3
environment UNKs: ['unregister', 'allocation', 'expirer', 'transition', 'rm', 'clean', 'container,allocation,expirer', 'rm,container,impl', 'rm,container,event', 'rm,node,clean,container,event', 'event,handler', 'node,id', 'container,id']
Known subtokens to predict: ['container', 'id', 'get'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.045): ObjEx(Cls(container))
	(0.027): ObjEx(Cls(container),Fld(Nm(container),Nm(container,id)),Nm(container))
	(0.025): Cal(Nm(container),Nm(get,container,id))
	(0.013): Fld(Nm(container),Nm(container,id))
	(0.006): Cal(Nm(container),Nm(get,container))

seq2seq:
	event . get _ id ( )
	container . <unk>
	event . get _ component ( )
	event . get _ source ( )
	event . get _ <unk> _ id ( )


seq2tree:
	Cal ( Nm ( event ) , Nm ( get , point ) )
	Cal ( Nm ( event ) , Nm ( get , id ) )
	Fld ( Nm ( container ) , Nm ( node , id ) )
	Fld ( Nm ( container ) , Nm ( container , id ) )
	Fld ( Nm ( container ) , Nm ( container , allocation , container )

------------------------------------------------------------------------------------

@Override
public List<NodeReport> getNodeReports(NodeState... states) throws YarnException, IOException {
    EnumSet<NodeState> statesSet = (states.length == 0) ?  !!! EnumSet.allOf(NodeState.class) !!!  : EnumSet.noneOf(NodeState.class);
    for (NodeState state : states) {
        statesSet.add(state);
    }
    GetClusterNodesRequest request = GetClusterNodesRequest.newInstance(statesSet);
    GetClusterNodesResponse response = rmClient.getClusterNodes(request);
    return response.getNodeReports();
}

Truth:	  enum _ set . all _ of ( node _ state . class )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/YarnClientImpl.java :435
true_ref: Cal(Nm(enum,set),Nm(all,of),ClsEx(Cls(node,state))) predicted at: 1, tree predicted at: 1
environment UNKs: ['states', 'reports', 'yarn', 'report', 'rm', 'none,of', 'states,set', 'enum,set', 'node,state', 'io,exception', 'get,node,reports', 'yarn,exception', 'node,report', 'get,cluster,nodes,response', 'get,cluster,nodes,request', 'rm,client', 'new,instance', 'get,cluster,nodes']
Known subtokens to predict: ['of', 'all'], UNK-available: ['node,state', 'enum,set'], UNK-unavailable: []
hyps:
	(0.326): Cal(Nm(enum,set),Nm(all,of),ClsEx(Cls(node,state)))
	(0.102): Fld(Nm(enum,set),Nm(empty))
	(0.031): ObjEx(Cls(linked,hash,set))
	(0.030): ObjEx(Cls(enum,set))
	(0.029): Cal(Nm(enum,set),Nm(all,of),ClsEx(Cls(enum,set)))

seq2seq:
	immutable _ set . of ( )
	immutable _ list . of ( )
	enum _ set . none _ of ( node _ state . class )
	enum _ set . all _ of ( node _ state . class )		(CORRECT!)
	enum _ set . of ( node _ state . class )

seq2tree:
	Cal ( Nm ( enum , set ) , Nm ( of ) , ClsEx ( Cls ( node , state ) ) )
	Cal ( Nm ( enum , set ) , Nm ( of ) )
	Cal ( Nm ( enum , set ) , Nm ( all , of ) , ClsEx ( Cls ( node , state ) ) )		(CORRECT!)
	Cal ( Nm ( immutable , set ) , Nm ( of ) )
	ObjEx ( Cls ( enum , set ) )
------------------------------------------------------------------------------------

static String replaceSubstitution(String base, Pattern from, String to, boolean repeat) {
    Matcher match = from.matcher(base);
    if (repeat) {
        return  !!! match.replaceAll(to) !!! ;
    } else {
        return match.replaceFirst(to);
    }
}

Truth:	  match . replace _ all ( to )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/KerberosName.java :284
true_ref: Cal(Nm(match),Nm(replace,all),Nm(to)) predicted at: 2, tree predicted at: 2
environment UNKs: ['repeat', 'substitution', 'replace,substitution', 'replace,first']
Known subtokens to predict: ['match', 'all', 'to', 'replace'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.016): Cal(Nm(match),Nm(to,string))
	(0.009): Cal(Nm(match),Nm(replace,all),Nm(to))
	(0.008): Cal(Nm(string,util),Nm(replace),Nm(match),Nm(to))
	(0.007): Cal(Nm(match),Nm(replace),Nm(base),Nm(to),Nm(match))
	(0.007): Cal(Nm(match),Nm(replace),Nm(base),Nm(to))

seq2seq:
	match . get _ first ( )
	match . replace _ first ( to )
	match . replace _ first ( to , to )
	match . replace _ first ( to , " _ <unk> )
	match . replace _ first ( " _ <unk> , to )

seq2tree:
	Cal ( Nm ( match ) , Nm ( replace , first ) , Nm ( base ) )
	Cal ( Nm ( match ) , Nm ( replace , first ) , Nm ( to ) )
	Cal ( Nm ( match ) , Nm ( replace , first ) , Nm ( repeat ) )
	Cal ( Nm ( match ) , Nm ( replace , first ) , Nm ( from ) )
	Cal ( Nm ( match ) , Nm ( replace , first ) , Nm ( base ) , Nm ( to ) )
------------------------------------------------------------------------------------

public static byte[] getXAttr(final Map<?, ?> json, final String name) throws IOException {
    if (json == null) {
        return null;
    }
    Map<String, byte[]> xAttrs = toXAttrs(json);
    if (xAttrs != null) {
        return  !!! xAttrs.get(name) !!! ;
    }
    return null;
}

Truth:	  x _ attrs . get ( name )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/JsonUtil.java :725
true_ref: Cal(Nm(x,attrs),Nm(get),Nm(name)) predicted at: 1, tree predicted at: 1
environment UNKs: ['attrs', 'x,attrs', 'io,exception', 'get,x,attr', 'to,x,attrs']
Known subtokens to predict: ['name', 'get'], UNK-available: ['x,attrs'], UNK-unavailable: []
hyps:
	(0.210): Cal(Nm(x,attrs),Nm(get),Nm(name))
	(0.042): Cal(Nm(x,attrs),Nm(to,byte,array))
	(0.038): Cal(Nm(x,attrs),Nm(get,byte,array),Nm(name))
	(0.038): Cal(Nm(x,attrs),Nm(to,byte,array),Nm(x,attrs))
	(0.026): Cal(Nm(x,attrs),Nm(get,x,attr),Nm(name))

seq2seq:
	x _ attrs . get _ bytes ( )
	new byte [ 0 ]
	x _ attrs . to _ byte _ array ( )
	array _ util . to _ byte _ array ( x _ attrs )
	x _ attrs . get _ bytes ( " _ <unk> _ <unk> )

seq2tree:
	Cal ( Nm ( x , attrs ) , Nm ( get ) , Nm ( name ) )		(CORRECT!)
	Cal ( Nm ( x , attrs ) , Nm ( get ) )
	Cal ( Nm ( x , attrs ) , Nm ( get ) , IntEx ( 0 ) )
	Cal ( Nm ( x , attrs ) , Nm ( to , array ) )
	Cal ( Nm ( x , attrs ) , Nm ( get , bytes ) , Nm ( name )
------------------------------------------------------------------------------------

static EnumSet<FileAttribute> parse(String s) {
    if (s == null || s.length() == 0) {
        return EnumSet.allOf(FileAttribute.class);
    }
    EnumSet<FileAttribute> set = EnumSet.noneOf(FileAttribute.class);
    FileAttribute[] attributes = values();
    for (char c :  !!! s.toCharArray() !!! ) {
        int i = 0;
        for (; i < attributes.length && c != attributes[i].symbol; i++) ;
        if (i < attributes.length) {
            if (!set.contains(attributes[i])) {
                set.add(attributes[i]);
            } else {
                throw new IllegalArgumentException("There are more than one '" + attributes[i].symbol + "' in " + s);
            }
        } else {
            throw new IllegalArgumentException("'" + c + "' in " + s + " is undefined.");
        }
    }
    return set;
}

Truth:	  s . to _ char _ array ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/DistCpV1.java :177
true_ref: Cal(Nm(s),Nm(to,char,array)) predicted at: 2, tree predicted at: 2
environment UNKs: ['undefined', 'there', 'than', 'file,attribute', 'enum,set', 'illegal,argument,exception', 'all,of', 'none,of', 'is,undefined', 'there,are,more,than,one']
Known subtokens to predict: ['array', 'to', 's', 'char'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.168): Fld(Nm(attributes),Nm(length))
	(0.143): Cal(Nm(s),Nm(to,char,array))
	(0.130): Cal(Nm(s),Nm(length))
	(0.023): Cal(Nm(s),Nm(get,bytes))
	(0.010): Cal(Nm(s),Nm(split),StrEx(/))

seq2seq:
	attributes . length
	attributes [ 0 ] . <unk>
	attributes [ 0 ] . next
	attributes [ 0 ] . line
	attributes [ 0 ]

seq2tree:
	Cal ( Nm ( set ) , Nm ( to , array ) )
	Cal ( Nm ( s ) , Nm ( to , char , array ) )		(CORRECT!)
	Cal ( Nm ( set ) , Nm ( to , char , array ) )
	Cal ( Nm ( set ) , Nm ( values ) )
	Cal ( Nm ( set ) , Nm ( to , array ) , Nm ( attributes ) )

-----------------------------------------------------------------------------------

private FinalizedReplica updateReplicaUnderRecovery(String bpid, ReplicaUnderRecovery rur, long recoveryId, long newlength) throws IOException {
    //
    if (rur.getRecoveryID() != recoveryId) {
        throw new IOException("rur.getRecoveryID() != recoveryId = " + recoveryId + ", rur=" + rur);
    }
    //
    bumpReplicaGS(rur, recoveryId);
    //
    final File replicafile = rur.getBlockFile();
    if (rur.getNumBytes() < newlength) {
        throw new IOException("rur.getNumBytes() < newlength = " + newlength + ", rur=" + rur);
    }
    if ( !!! rur.getNumBytes() > newlength !!! ) {
        rur.unlinkBlock(1);
        truncateBlock(replicafile, rur.getMetaFile(), rur.getNumBytes(), newlength);
        //
        rur.setNumBytes(newlength);
    }
    //
    return finalizeReplica(bpid, rur);
}

Truth:	  rur . get _ num _ bytes ( ) > newlength
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/FsDatasetImpl.java :1797
true_ref: Gt(Cal(Nm(rur),Nm(get,num,bytes)),Nm(newlength)) predicted at: 4, tree predicted at: 4
environment UNKs: ['replica', 'under', 'recovery', 'finalized', 'rur', 'replicafile', 'truncate', 'newlength', 'bump', 'gs', 'unlink', 'bpid', 'finalize', 'rurget', '<', 'io,exception', 'update,replica,under,recovery', 'finalized,replica', 'replica,under,recovery', 'recovery,id', 'set,num,bytes', 'truncate,block', 'bump,replica,gs', 'unlink,block', 'finalize,replica', 'get,num,bytes', 'get,meta,file', 'get,block,file', 'rurget,num,bytes,<,newlength,=']
Known subtokens to predict: [], UNK-available: ['newlength', 'rur', 'get,num,bytes'], UNK-unavailable: []
hyps:
	(0.089): Not(Cal(Nm(replicafile),Nm(exists)))
	(0.058): Neq(Cal(Nm(rur),Nm(get,meta,file)),Null(null))
	(0.043): Cal(Nm(rur),Nm(exists))
	(0.042): Gt(Cal(Nm(rur),Nm(get,num,bytes)),Nm(newlength))
	(0.038): Gt(Cal(Nm(rur),Nm(get,num,bytes)),Nm(replicafile))

seq2seq:
	rur != null
	rur . get _ num _ bytes ( ) > 0
	replicafile . get _ num _ bytes ( ) > 0
	rur . is _ directory ( )
	rur . get _ num _ bytes ( ) > 1


seq2tree:
	gs ( Cal ( Nm ( rur ) , Nm ( get , num , bytes ) ) , IntEx ( 0 ) )
	Neq ( Cal ( Nm ( rur ) , Nm ( get , meta , file ) ) , Null ( null ) )
	gs ( Cal ( Nm ( rur ) , Nm ( get , num , bytes ) ) , IntEx ( 1 ) )
	Eq ( Cal ( Nm ( rur ) , Nm ( get , num , bytes ) ) , IntEx ( 0 ) )
	gs ( Cal ( Nm ( rur ) , Nm ( get , num , bytes ) ) , IntEx ( newlength ) )
------------------------------------------------------------------------------------

public static Path[] stat2Paths(FileStatus[] stats) {
    if (stats == null)
        return null;
    Path[] ret = new Path[stats.length];
    for (int i = 0; i < stats.length; ++i) {
        ret[i] =  !!! stats[i].getPath() !!! ;
    }
    return ret;
}

Truth:	  stats [ i ] . get _ path ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/FileUtil.java :78
true_ref: Cal(ArAc(Nm(stats),Nm(i)),Nm(get,path)) predicted at: 1, tree predicted at: 1
environment UNKs: ['ret', 'stat', 'stat,paths', 'file,status']
Known subtokens to predict: ['path', 'stats', 'i', 'get'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.057): Cal(ArAc(Nm(stats),Nm(i)),Nm(get,path))
	(0.047): ObjEx(Cls(path),ArAc(Nm(stats),Nm(i)),Nm(ret))
	(0.038): StaticCall(Nm(stat,paths),ArAc(Nm(stats),Nm(i)),Nm(ret))
	(0.036): StaticCall(Nm(stat),ArAc(Nm(stats),Nm(i)),Nm(ret))
	(0.013): ObjEx(Cls(path),ArAc(Nm(stats),Nm(i)),Nm(file,status))

seq2seq:
	stats [ i ]
	new path ( stats [ i ] )
	stats [ i ] . to _ string ( )
	stats [ i ] . to _ path ( )
	new file ( stats [ i ] , " _ <unk> )

seq2tree:
	ArAc ( Nm ( stats ) , Nm ( i ) )
	ObjEx ( Cls ( path ) , ArAc ( Nm ( stats ) , Nm ( i ) ) )
	StaticCall ( Nm ( stat ) , ArAc ( Nm ( stats ) , Nm ( i ) ) )
	Cal ( ArAc ( Nm ( stats ) , Nm ( i ) ) , Nm ( to , path ) )
	Cal ( ArAc ( Nm ( stats ) , Nm ( i ) ) , Nm ( get , path ) )		(CORRECT!)
------------------------------------------------------------------------------------

void ensureCurrentDirExists() throws IOException {
    for (Iterator<StorageDirectory> it = storage.dirIterator(); it.hasNext(); ) {
        StorageDirectory sd = it.next();
        File curDir = sd.getCurrentDir();
        if ( !!! !curDir.exists() !!!  && !curDir.mkdirs()) {
            throw new IOException("Could not create directory " + curDir);
        }
    }
}

Truth:	  ! cur _ dir . exists ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/SecondaryNameNode.java :1014
true_ref: Not(Cal(Nm(cur,dir),Nm(exists))) predicted at: 1, tree predicted at: 1
environment UNKs: ['mkdirs', 'ensure', 'sd', 'could', 'cur,dir', 'io,exception', 'has,next', 'storage,directory', 'ensure,current,dir,exists', 'could,not,create,directory', 'get,current,dir', 'dir,iterator']
Known subtokens to predict: ['exists'], UNK-available: ['cur,dir'], UNK-unavailable: []
hyps:
	(0.606): Not(Cal(Nm(cur,dir),Nm(exists)))
	(0.125): Cal(Nm(cur,dir),Nm(exists))
	(0.107): Neq(Nm(cur,dir),Null(null))
	(0.065): Not(Cal(Nm(cur,dir),Nm(is,directory)))
	(0.004): Not(Cal(Nm(sd),Nm(is,directory)))

seq2seq:
	cur _ dir != null
	cur _ dir . exists ( )
	sd != null
	! cur _ dir . exists ( )		(CORRECT!)
	sd . is _ directory ( )

seq2tree:
	Neq ( Nm ( cur , dir ) , Null ( null ) )
	Cal ( Nm ( cur , dir ) , Nm ( exists ) )
	Not ( Cal ( Nm ( cur , dir ) , Nm ( exists ) ) )		(CORRECT!)
	Enc ( Neq ( Nm ( cur , dir ) , Null ( null ) ) )
	storage ( Neq ( Nm ( cur , dir ) , Null ( null ) ) , Cal ( Nm ( cur , dir ) , Nm ( exists ) ) )

------------------------------------------------------------------------------------

private synchronized void initJournals(List<URI> dirs) {
    int minimumRedundantJournals = conf.getInt(DFSConfigKeys.DFS_NAMENODE_EDITS_DIR_MINIMUM_KEY, DFSConfigKeys.DFS_NAMENODE_EDITS_DIR_MINIMUM_DEFAULT);
    journalSet = new JournalSet(minimumRedundantJournals);
    for (URI u : dirs) {
        boolean required = FSNamesystem.getRequiredNamespaceEditsDirs(conf).contains(u);
        if ( !!! u.getScheme() !!! .equals(NNStorage.LOCAL_URI_SCHEME)) {
            StorageDirectory sd = storage.getStorageDirectory(u);
            if (sd != null) {
                journalSet.add(new FileJournalManager(conf, sd, storage), required, sharedEditsDirs.contains(u));
            }
        } else {
            journalSet.add(createJournal(u), required, sharedEditsDirs.contains(u));
        }
    }
    if (journalSet.isEmpty()) {
        LOG.error("No edits directories configured!");
    }
}

Truth:	  u . get _ scheme ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/FSEditLog.java :260
true_ref: Cal(Nm(u),Nm(get,scheme)) predicted at: 1, tree predicted at: 1
environment UNKs: ['nn', 'dirs', 'sd', 'shared', 'edits', 'journals', 'minimum', 'redundant', 'conf', 'fs', 'namesystem', 'directories', 'configured', 'dfs', 'namenode', 'local,uri,scheme', 'nn,storage', 'journal,set', 'storage,directory', 'shared,edits,dirs', 'create,journal', 'init,journals', 'is,empty', 'get,storage,directory', 'minimum,redundant,journals', 'get,required,namespace,edits,dirs', 'fs,namesystem', 'file,journal,manager', 'no,edits,directories,configured', 'get,int', 'dfs,config,keys', 'dfs,namenode,edits,dir,minimum,key', 'dfs,namenode,edits,dir,minimum,default']
Known subtokens to predict: ['u', 'scheme', 'get'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.134): Cal(Nm(u),Nm(get,scheme))
	(0.119): Cal(Nm(u),Nm(get,name))
	(0.043): Cal(Nm(u),Nm(get,local,name))
	(0.043): Fld(Nm(boolean),Nm(true))
	(0.026): Cal(Nm(u),Nm(get,nn))

seq2seq:
	u . to _ string ( )
	boolean . true
	u . get _ uri ( )
	u . boolean _ value ( )
	u . get _ name ( )

seq2tree:
	Cal ( Nm ( u ) , Nm ( get , scheme ) )		(CORRECT!)
	Cal ( Nm ( u ) , Nm ( get , name ) )
	Cal ( Nm ( storage ) , Nm ( get , local , uri , scheme ) )
	Fld ( Nm ( dfs , config , keys ) , Nm ( dfs , scheme ) )
	Fld ( Nm ( dfs , config , keys ) , Nm ( dfs , storage ) )
------------------------------------------------------------------------------------

private void setFlag(long flag) {
    long prev;
    do {
        prev = unsafe.getLongVolatile(null, this.slotAddress);
        if ( !!! (prev & flag) !!!  != 0) {
            return;
        }
    } while (!unsafe.compareAndSwapLong(null, this.slotAddress, prev, prev | flag));
}

Truth:	  ( prev & flag )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/ShortCircuitShm.java :325
true_ref: Enc(BinAnd(Nm(prev),Nm(flag))) predicted at: 1, tree predicted at: 1
environment UNKs: ['unsafe', 'swap', 'volatile', 'slot', 'set,flag', 'compare,and,swap,long', 'get,long,volatile', 'slot,address']
Known subtokens to predict: ['flag', 'prev'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.716): Enc(BinAnd(Nm(prev),Nm(flag)))
	(0.020): Fld(This(this),Nm(slot,address))
	(0.012): Enc(BinAnd(Nm(prev),Nm(flag,mask)))
	(0.003): Enc(BinAnd(Nm(prev),Nm(flag,slot)))
	(0.002): Enc(BinAnd(Nm(prev),Fld(Nm(long),Nm(max,value))))

seq2seq:
	prev
	prev + 1
	prev - 1
	( prev & <unk> )
	( prev & 0 _ <unk> )

seq2tree:
	unsafe ( Nm ( prev ) , Nm ( flag ) )
	Enc ( volatile ( Nm ( prev ) , Nm ( flag ) ) )
	Enc ( volatile ( Nm ( prev ) , Cal ( Nm ( unsafe ) , Nm ( get ) ) ) )
	Enc ( volatile ( Nm ( prev ) , Cal ( Nm ( unsafe ) , Nm ( get , long , volatile ) , Null ( null ) , Nm ( prev ) ) ) )
	Enc ( volatile ( Nm ( prev ) , Cal ( Nm ( unsafe ) , Nm ( get , long , volatile ) , Null ( null ) ) ) )
------------------------------------------------------------------------------------

public RawComparator getCombinerKeyGroupingComparator() {
    Class<? extends RawComparator> theClass = getClass(JobContext.COMBINER_GROUP_COMPARATOR_CLASS, null,  !!! RawComparator.class !!! );
    if (theClass == null) {
        return getOutputKeyComparator();
    }
    return ReflectionUtils.newInstance(theClass, this);
}

Truth:	  raw _ comparator . class
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/JobConf.java :963
true_ref: ClsEx(Cls(raw,comparator)) predicted at: 1, tree predicted at: 1
environment UNKs: ['combiner', 'job', 'grouping', 'reflection', 'get,class', 'combiner,group,comparator,class', 'job,context', 'the,class', 'raw,comparator', 'get,combiner,key,grouping,comparator', 'reflection,utils', 'new,instance', 'get,output,key,comparator']
Known subtokens to predict: [], UNK-available: ['raw,comparator'], UNK-unavailable: []
hyps:
	(0.162): ClsEx(Cls(raw,comparator))
	(0.064): Fld(Nm(job,context),Nm(combiner))
	(0.032): Fld(Nm(job,context),Nm(combiner,version,class))
	(0.017): StaticCall(Nm(get,type))
	(0.011): Fld(Nm(job,type),Nm(combiner))

seq2seq:
	object . class
	global _ search _ scope . all _ scope ( project )
	global _ search _ scope . all _ scope ( my _ project )
	new object [ ] { null }
	new object [ ] { " _ <unk> , " _ <unk> }

seq2tree:
	ClsEx ( Cls ( string ) )
	ClsEx ( Cls ( raw ) )
	ClsEx ( Cls ( object ) )
	ClsEx ( Cls ( raw , comparator ) )		(CORRECT!)
	ClsEx ( Cls ( raw , comparator , comparator ) )
------------------------------------------------------------------------------------

public static Map<JobId, Job> newJobs(ApplicationId appID, int numJobsPerApp, int numTasksPerJob, int numAttemptsPerTask) {
    Map<JobId, Job> map = Maps.newHashMap();
    for (int j = 0;  !!! j < numJobsPerApp !!! ; ++j) {
        Job job = newJob(appID, j, numTasksPerJob, numAttemptsPerTask);
        map.put(job.getID(), job);
    }
    return map;
}

Truth:	  j < num _ jobs _ per _ app
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/MockJobs.java :130
true_ref: Ls(Nm(j),Nm(num,jobs,per,app)) predicted at: 1, tree predicted at: 1
environment UNKs: ['jobs', 'job', 'attempts', 'maps', 'new,jobs', 'job,id', 'num,attempts,per,task', 'app,id', 'num,jobs,per,app', 'num,tasks,per,job', 'application,id', 'get,id', 'new,job', 'new,hash,map']
Known subtokens to predict: ['j'], UNK-available: ['num,jobs,per,app'], UNK-unavailable: []
hyps:
	(0.915): Ls(Nm(j),Nm(num,jobs,per,app))
	(0.024): Neq(Nm(j),Nm(num,jobs,per,app))
	(0.016): Ls(Nm(j),Nm(num,tasks,per,job))
	(0.007): Neq(Nm(j),IntEx(0))
	(0.005): Ls(Nm(j),Cal(Nm(num,jobs,per,app),Nm(size)))

seq2seq:
	j < num _ attempts _ per _ task
	j < num _ jobs _ per _ task
	j < num _ tasks _ per _ task
	j < num _ attempts _ per _ app
	j < num _ jobs _ per _ app		(CORRECT!)

seq2tree:
	VDE ( Prim ( int ) , VD ( VDID ( j ) , IntEx ( 0 ) ) )		(CORRECT!)
	VDE ( Prim ( int ) , VD ( VDID ( j ) , Nm ( num , jobs , per , app ) ) )
	VDE ( Prim ( int ) , VD ( VDID ( j ) , IntEx ( 1 ) ) )
	VDE ( Prim ( int ) , VD ( VDID ( j ) , Nm ( num , tasks , per , job ) ) )
	VDE ( Prim ( int ) , VD ( VDID ( j ) , Nm ( num , jobs , per , job ) ) )
------------------------------------------------------------------------------------

@Override
public ProtocolProxy<ProtocolMetaInfoPB> getProtocolMetaInfoProxy(ConnectionId connId, Configuration conf, SocketFactory factory) throws IOException {
    Class<ProtocolMetaInfoPB> protocol =  !!! ProtocolMetaInfoPB.class !!! ;
    return new ProtocolProxy<ProtocolMetaInfoPB>(protocol, (ProtocolMetaInfoPB) Proxy.newProxyInstance(protocol.getClassLoader(), new Class[] { protocol }, new Invoker(protocol, connId, conf, factory)), false);
}

Truth:	  protocol _ meta _ info _ pb . class
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/ProtobufRpcEngine.java :100
true_ref: ClsEx(Cls(protocol,meta,info,pb)) predicted at: 1, tree predicted at: 1
environment UNKs: ['pb', 'conf', 'conn', 'invoker', 'protocol,meta,info,pb', 'get,protocol,meta,info,proxy', 'io,exception', 'protocol,proxy', 'connection,id', 'socket,factory', 'conn,id', 'new,proxy,instance', 'get,class,loader']
Known subtokens to predict: [], UNK-available: ['protocol,meta,info,pb'], UNK-unavailable: []
hyps:
	(0.354): ClsEx(Cls(protocol,meta,info,pb))
	(0.054): StaticCall(Nm(get,protocol),Nm(conn,id))
	(0.037): StaticCall(Nm(get,protocol),Nm(factory))
	(0.033): Cal(Nm(conf),Nm(get,protocol))
	(0.015): StaticCall(Nm(get,protocol))

seq2seq:
	get _ protocol ( )
	get _ protocol ( conn _ id )
	<unk> . get _ protocol ( )
	get _ protocol _ factory ( ) . get _ protocol ( )
	get _ protocol ( conn _ id , conf )

seq2tree:
	StaticCall ( Nm ( get , protocol ) , Nm ( conn , id ) )
	Cal ( Nm ( factory ) , Nm ( get , protocol ) )
	StaticCall ( Nm ( get , protocol ) , Nm ( conn , id ) , Nm ( conf ) )
	StaticCall ( Nm ( load , protocol ) , Nm ( conn , id ) )
	Cal ( Nm ( protocol , meta , info , pb ) , Nm ( get ) )
------------------------------------------------------------------------------------

@Override
public void setup(Context context) throws IOException, InterruptedException {
    conf = context.getConfiguration();
    syncFolders = conf.getBoolean(DistCpOptionSwitch.SYNC_FOLDERS.getConfigLabel(), false);
    ignoreFailures = conf.getBoolean(DistCpOptionSwitch.IGNORE_FAILURES.getConfigLabel(), false);
    skipCrc = conf.getBoolean( !!! DistCpOptionSwitch.SKIP_CRC !!! .getConfigLabel(), false);
    overWrite = conf.getBoolean(DistCpOptionSwitch.OVERWRITE.getConfigLabel(), false);
    append = conf.getBoolean(DistCpOptionSwitch.APPEND.getConfigLabel(), false);
    preserve = DistCpUtils.unpackAttributes(conf.get(DistCpOptionSwitch.PRESERVE_STATUS.getConfigLabel()));
    targetWorkPath = new Path(conf.get(DistCpConstants.CONF_LABEL_TARGET_WORK_PATH));
    Path targetFinalPath = new Path(conf.get(DistCpConstants.CONF_LABEL_TARGET_FINAL_PATH));
    targetFS = targetFinalPath.getFileSystem(conf);
    if (targetFS.exists(targetFinalPath) && targetFS.isFile(targetFinalPath)) {
        //
        overWrite = true;
    }
    if (conf.get(DistCpConstants.CONF_LABEL_SSL_CONF) != null) {
        initializeSSLConf(context);
    }
}

Truth:	  dist _ cp _ option _ switch . skip _ crc
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/CopyMapper.java :103
true_ref: Fld(Nm(dist,cp,option,switch),Nm(skip,crc)) predicted at: 1, tree predicted at: 1
environment UNKs: ['conf', 'crc', 'setup', 'interrupted', 'fs', 'over', 'folders', 'preserve', 'work', 'failures', 'dist', 'cp', 'unpack', 'initialize', 'ssl', 'switch', 'overwrite', 'get,config,label', 'get,boolean', 'skip,crc', 'io,exception', 'interrupted,exception', 'target,fs', 'over,write', 'sync,folders', 'target,work,path', 'ignore,failures', 'is,file', 'get,file,system', 'target,final,path', 'get,configuration', 'dist,cp,utils', 'unpack,attributes', 'initialize,ssl,conf', 'conf,label,ssl,conf', 'dist,cp,constants', 'dist,cp,option,switch', 'conf,label,target,work,path', 'conf,label,target,final,path', 'preserve,status']
Known subtokens to predict: [], UNK-available: ['dist,cp,option,switch', 'skip,crc'], UNK-unavailable: []
hyps:
	(0.915): Fld(Nm(dist,cp,option,switch),Nm(skip,crc))
	(0.013): Fld(Nm(dist,cp,option,switch),Nm(crc))
	(0.004): Cal(Fld(Nm(dist,cp,option,switch),Nm(skip,crc)),Nm(get),IntEx(0))
	(0.003): Cal(Fld(Nm(dist,cp,option,switch),Nm(skip,crc)),Nm(get),Nm(dist))
	(0.001): Cal(Fld(Nm(dist,cp,option,switch),Nm(skip,crc)),Nm(get),Nm(conf))

seq2seq:
	dist _ cp _ option _ switch . crc . get _ config _ label ( )
	dist _ cp _ option _ switch . overwrite . get _ config _ label ( )
	dist _ cp _ option _ switch . skip _ failures . get _ config _ label ( )
	dist _ cp _ option _ switch . sync _ folders . get _ config _ label ( )
	dist _ cp _ option _ switch . ignore _ failures . get _ config _ label ( )

seq2tree:
	Cal ( Fld ( Nm ( dist , cp , option , switch ) , Nm ( overwrite , failures ) ) , Nm ( get , config , label ) )
	Cal ( Fld ( Nm ( dist , cp , option , switch ) , Nm ( ignore , failures ) ) , Nm ( get , config , label ) )
	Cal ( Fld ( Nm ( dist , cp , option , switch ) , Nm ( overwrite ) ) , Nm ( get , config , label ) )
	Cal ( Fld ( Nm ( dist , cp , option , switch ) , Nm ( overwrite , status ) ) , Nm ( get , config , label ) )
	Cal ( Fld ( Nm ( dist , cp , option , switch ) , Nm ( append , failures ) ) , Nm ( get , config , label ) )
------------------------------------------------------------------------------------

public void refreshLoadedJobCache() {
    if (getServiceState() == STATE.STARTED) {
        if (storage instanceof CachedHistoryStorage) {
            ((CachedHistoryStorage) storage).refreshLoadedJobCache();
        } else {
            throw new UnsupportedOperationException(storage.getClass().getName() + " is expected to be an instance of " +  !!! CachedHistoryStorage.class.getName() !!! );
        }
    } else {
        LOG.warn("Failed to execute refreshLoadedJobCache: JobHistory service is not started");
    }
}

Truth:	  cached _ history _ storage . class . get _ name ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/JobHistory.java :245
true_ref: Cal(ClsEx(Cls(cached,history,storage)),Nm(get,name)) predicted at: 1, tree predicted at: 1
environment UNKs: ['loaded', 'job', 'started', 'is,expected,to,be,an,instance,of', 'unsupported,operation,exception', 'get,name', 'get,class', 'cached,history,storage', 'refresh,loaded,job,cache', 'get,service,state', 'failed,to,execute,refresh,loaded,job,cache,job,history,service,is,not,started']
Known subtokens to predict: [], UNK-available: ['get,name', 'cached,history,storage'], UNK-unavailable: []
hyps:
	(0.569): Cal(ClsEx(Cls(cached,history,storage)),Nm(get,name))
	(0.030): Cal(Cal(Nm(e),Nm(get,class)),Nm(get,name))
	(0.015): Cal(Cal(Nm(application,names,info),Nm(get,class)),Nm(get,name))
	(0.013): Cal(Cal(Nm(ex),Nm(get,class)),Nm(get,name))
	(0.003): Cal(Cal(Nm(e),Nm(get,class)),Nm(get,simple,name))

seq2seq:
	get _ class ( ) . get _ name ( )
	get _ class ( ) . get _ simple _ name ( )
	this . get _ class ( ) . get _ name ( )
	get _ class ( ) . get _ canonical _ name ( )
	get _ class ( )

seq2tree:
	Cal ( Nm ( storage ) , Nm ( get , class ) )
	Cal ( StaticCall ( Nm ( get , class ) ) , Nm ( get , name ) )
	Cal ( Nm ( storage ) , Nm ( get , name ) )
	Cal ( Nm ( storage ) , Nm ( get , path ) )
	Cal ( StaticCall ( Nm ( get , class ) ) , Nm ( get , simple , name ) )
------------------------------------------------------------------------------------

static int getSplitRatio(int nMaps, int nRecords, Configuration conf) {
    int maxChunksIdeal = getMaxChunksIdeal(conf);
    int minRecordsPerChunk = getMinRecordsPerChunk(conf);
    int splitRatio = getSplitRatio(conf);
    if (nMaps == 1) {
        LOG.warn("nMaps == 1. Why use DynamicInputFormat?");
        return 1;
    }
    if (nMaps > maxChunksIdeal)
        return splitRatio;
    int nPickups = (int) Math.ceil((float) maxChunksIdeal / nMaps);
    int nRecordsPerChunk = (int) Math.ceil( !!! (float) nRecords !!!  / (nMaps * nPickups));
    return nRecordsPerChunk < minRecordsPerChunk ? splitRatio : nPickups;
}

Truth:	  ( float ) n _ records
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/DynamicInputFormat.java :329
true_ref: Cast(Prim(float),Nm(n,records)) predicted at: 1, tree predicted at: 1
environment UNKs: ['ceil', 'maps', 'pickups', 'records', 'ratio', 'chunks', 'ideal', 'conf', '==', 'why', 'n,maps', 'n,pickups', 'n,records,per,chunk', 'get,split,ratio', 'split,ratio', 'max,chunks,ideal', 'n,records', 'min,records,per,chunk', 'n,maps,==,.,why,use,dynamic,input,format']
Known subtokens to predict: ['float'], UNK-available: ['n,records'], UNK-unavailable: []
hyps:
	(0.129): Cast(Prim(float),Nm(n,records))
	(0.057): Cast(Prim(float),Nm(conf))
	(0.035): Cast(Prim(float),Nm(n,maps))
	(0.006): Enc(Mul(Nm(conf),Nm(n,max,int)))
	(0.003): Enc(Mul(Nm(conf),Nm(n,records)))

seq2seq:
	( n _ pickups * n _ pickups )
	( n _ pickups * n _ maps )
	( n _ pickups * n _ records )
	( n _ maps * n _ pickups )
	( max _ chunks _ ideal / n _ maps )

seq2tree:
	Cast ( Prim ( double ) , Nm ( n , pickups ) )
	Enc ( maps ( Nm ( n , pickups ) , Nm ( n , pickups ) ) )
	Enc ( Minus ( Nm ( n , pickups ) , Nm ( n , pickups ) ) )
	why ( Nm ( n , pickups ) , Nm ( n , pickups ) )
	Cast ( Prim ( int ) , Enc ( 1. ( Nm ( n , pickups ) , Nm ( n , pickups ) ) ) )
------------------------------------------------------------------------------------
private int readData(byte[] buf, int off, int len) throws IOException {
    int bytesRead = 0;
    while (bytesRead < len) {
        int n = IOUtils.wrappedReadForCompressedData(in, buf,  !!! off + bytesRead !!! , len - bytesRead);
        if (n < 0) {
            return bytesRead;
        }
        bytesRead += n;
    }
    return len;
}

Truth:	  off + bytes _ read
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/IFile.java :378
true_ref: Plus(Nm(off),Nm(bytes,read)) predicted at: 1, tree predicted at: 1
environment UNKs: ['wrapped', 'compressed', 'off', 'wrapped,read,for,compressed,data', 'bytes,read', 'read,data', 'io,exception']
Known subtokens to predict: [], UNK-available: ['bytes,read', 'off'], UNK-unavailable: []
hyps:
	(0.400): Plus(Nm(off),Nm(bytes,read))
	(0.214): Minus(Nm(bytes,read),Nm(bytes,read))
	(0.099): Minus(Nm(off),Nm(bytes,read))
	(0.028): Plus(Nm(bytes,read),Nm(off))
	(0.026): Minus(Nm(len),Nm(bytes,read))

seq2seq:
	- bytes _ read
	bytes _ read ++
	bytes _ read - bytes _ read
	byte _ buffer . <unk> ( bytes _ read )
	byte _ buffer . <unk> ( )

seq2tree:
	compressed ( Nm ( bytes , read ) )
	Plus ( Nm ( off ) , Nm ( bytes , read ) )		(CORRECT!)
	Minus ( Nm ( len ) , Nm ( bytes , read ) )
	Plus ( Nm ( off ) , Nm ( len ) )
	Minus ( Nm ( off ) , Nm ( bytes , read ) )
------------------------------------------------------------------------------------
private void ref(ShortCircuitReplica replica) {
    lock.lock();
    try {
        Preconditions.checkArgument(replica.refCount > 0, "can't ref " + replica + " because its refCount reached " + replica.refCount);
        Long evictableTimeNs = replica.getEvictableTimeNs();
        replica.refCount++;
        if ( !!! evictableTimeNs != null !!! ) {
            String removedFrom = removeEvictable(replica);
            if (LOG.isTraceEnabled()) {
                LOG.trace(this + ": " + removedFrom + " no longer contains " + replica + ".  refCount " + (replica.refCount - 1) + " -> " + replica.refCount + StringUtils.getStackTrace(Thread.currentThread()));
            }
        } else if (LOG.isTraceEnabled()) {
            LOG.trace(this + ": replica  refCount " + (replica.refCount - 1) + " -> " + replica.refCount + StringUtils.getStackTrace(Thread.currentThread()));
        }
    } finally {
        lock.unlock();
    }
}

Truth:	  evictable _ time _ ns != null
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/ShortCircuitCache.java :407
true_ref: Neq(Nm(evictable,time,ns),Null(null)) predicted at: 1, tree predicted at: 1
environment UNKs: ['preconditions', 'removed', 'evictable', 'ns', 'replica', 'unlock', 'because', 'its', 'reached', 'circuit', 'cant', '->', 'longer', 'is,trace,enabled', 'check,argument', 'removed,from', 'evictable,time,ns', 'ref,count', 'remove,evictable', 'get,evictable,time,ns', 'because,its,ref,count,reached', 'short,circuit,replica', 'string,utils', 'get,stack,trace', 'cant,ref', 'current,thread', ':,replica,ref,count', '.,ref,count', 'no,longer,contains']
Known subtokens to predict: ['null'], UNK-available: ['evictable,time,ns'], UNK-unavailable: []
hyps:
	(0.189): Neq(Nm(evictable,time,ns),Null(null))
	(0.157): Cal(Nm(log),Nm(is,trace,enabled))
	(0.086): Cal(Nm(log),Nm(is,debug,enabled))
	(0.039): Cal(Nm(log),Nm(is,enabled))
	(0.025): Gt(Fld(Nm(replica),Nm(ref,count)),IntEx(0))

seq2seq:
	evictable . ref _ count > 0
	replica . ref _ count > 0
	evictable _ time _ ns > 0
	evictable . ref _ count == 0
	<unk> . ref _ count > 0

seq2tree:
	circuit ( Fld ( Nm ( replica ) , Nm ( ref , count ) ) , IntEx ( 0 ) )
	circuit ( Fld ( Nm ( replica ) , Nm ( ref , count ) ) , IntEx ( 1 ) )
	circuit ( Nm ( evictable , time , ns ) , IntEx ( 0 ) )
	Eq ( Fld ( Nm ( replica ) , Nm ( ref , count ) ) , IntEx ( 0 ) )
	Neq ( Nm ( replica ) , Null ( null ) )
------------------------------------------------------------------------------------

private Path getPath(int curId, int limitPerDir, Type type) {
    if (curId <= 0) {
        return basePath;
    }
    String name = "";
    switch(type) {
        case FILE:
            name = FILE_PREFIX + new Integer(curId % limitPerDir).toString();
            break;
        case DIRECTORY:
            name = DIR_PREFIX + new Integer(curId % limitPerDir).toString();
            break;
    }
    Path base = getPath((curId / limitPerDir), limitPerDir, Type.DIRECTORY);
    return  !!! new Path(base, name) !!! ;
}

Truth:	  new path ( base , name )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/PathFinder.java :78
true_ref: ObjEx(Cls(path),Nm(base),Nm(name)) predicted at: 1, tree predicted at: 1
environment UNKs: ['get,path', 'cur,id', 'limit,per,dir', 'dir,prefix', 'file,prefix', 'to,string']
Known subtokens to predict: ['path', 'name', 'base'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.193): ObjEx(Cls(path),Nm(base),Nm(name))
	(0.106): ObjEx(Cls(path),Nm(base))
	(0.100): ObjEx(Cls(path),Nm(name),Nm(base))
	(0.028): ObjEx(Cls(path),Nm(name))
	(0.010): ObjEx(Cls(path),Nm(base),Nm(name),Nm(type))

seq2seq:
	new path ( base )
	new file ( base )
	new path ( base . get _ path ( ) )
	new path ( base , " _ <unk> )
	new path ( base . to _ uri ( ) )

seq2tree:
	ObjEx ( Cls ( path ) , Nm ( base ) )
	ObjEx ( Cls ( file ) , Nm ( base ) , Nm ( name ) )
	ObjEx ( Cls ( path ) , Nm ( base ) , Nm ( name ) )		(CORRECT!)
	path ( Eq ( Nm ( base ) , Null ( null ) ) , Nm ( unknown ) , Nm ( base ) )
	path ( Neq ( Nm ( base ) , Null ( null ) ) , Nm ( base ) , Null ( null ) )
------------------------------------------------------------------------------------

protected int getTmax(String metricName) {
    if (tmaxTable == null) {
        return DEFAULT_TMAX;
    }
    String tmaxString =  !!! tmaxTable.get(metricName) !!! ;
    if (tmaxString == null) {
        return DEFAULT_TMAX;
    } else {
        return Integer.parseInt(tmaxString);
    }
}

Truth:	  tmax _ table . get ( metric _ name )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/GangliaContext.java :203
true_ref: Cal(Nm(tmax,table),Nm(get),Nm(metric,name)) predicted at: 1, tree predicted at: 1
environment UNKs: ['tmax', 'metric', 'tmax,string', 'get,tmax', 'metric,name', 'tmax,table', 'default,tmax', 'parse,int']
Known subtokens to predict: ['get'], UNK-available: ['metric,name', 'tmax,table'], UNK-unavailable: []
hyps:
	(0.110): Cal(Nm(tmax,table),Nm(get),Nm(metric,name))
	(0.084): Cal(Nm(tmax,table),Nm(get,tmax))
	(0.051): Cal(Nm(tmax,table),Nm(get,tmax),Nm(metric,name))
	(0.044): StaticCall(Nm(get,tmax,string),Nm(metric,name))
	(0.008): Cal(Nm(tmax,table),Nm(get,tmax))

seq2seq:
	system . get _ property ( metric _ name )
	getter _ util . get _ string ( tmax _ table . get _ property ( metric _ name ) )
	getter _ util . get _ integer ( tmax _ table . get _ property ( metric _ name ) )
	getter _ util . get _ string ( tmax _ name )
	getter _ util . get _ integer ( tmax _ name )

seq2tree:
	Cal ( Nm ( tmax , table ) , Nm ( get ) , Nm ( metric , name ) )		(CORRECT!)
	Cast ( Cls ( string ) , Cal ( Nm ( tmax , table ) , Nm ( get ) , Nm ( metric , name ) ) )
	Cal ( Nm ( tmax , table ) , Nm ( get ) , Nm ( metric , name ) )		(CORRECT!)
	Cal ( Nm ( tmax , table ) , Nm ( get , value ) )
	Cal ( Nm ( tmax , table ) , Nm ( get , value ) , Nm ( metric , name ) )
------------------------------------------------------------------------------------

public static QueuePlacementPolicy fromXml(Element el, Map<FSQueueType, Set<String>> configuredQueues, Configuration conf) throws AllocationConfigurationException {
    List<QueuePlacementRule> rules = new ArrayList<QueuePlacementRule>();
    NodeList elements =  !!! el.getChildNodes() !!! ;
    for (int i = 0; i < elements.getLength(); i++) {
        Node node = elements.item(i);
        if (node instanceof Element) {
            QueuePlacementRule rule = createAndInitializeRule(node);
            rules.add(rule);
        }
    }
    return new QueuePlacementPolicy(rules, configuredQueues, conf);
}

Truth:	  el . get _ child _ nodes ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/QueuePlacementPolicy.java :85
true_ref: Cal(Nm(el),Nm(get,child,nodes)) predicted at: 1, tree predicted at: 1
environment UNKs: ['allocation', 'placement', 'conf', 'configured', 'queues', 'el', 'rules', 'fs', 'initialize', 'node,list', 'from,xml', 'allocation,configuration,exception', 'queue,placement,policy', 'configured,queues', 'get,length', 'fs,queue,type', 'queue,placement,rule', 'array,list', 'create,and,initialize,rule']
Known subtokens to predict: ['nodes', 'get', 'child'], UNK-available: ['el'], UNK-unavailable: []
hyps:
	(0.180): Cal(Nm(el),Nm(get,child,nodes))
	(0.090): Cal(Nm(el),Nm(get,child,elements))
	(0.072): ObjEx(Cls(node,list))
	(0.039): Cal(Nm(el),Nm(new,array,list))
	(0.013): ObjEx(Cls(node,list),Nm(el))

seq2seq:
	new node _ list ( )
	el . get _ child _ nodes ( )		(CORRECT!)
	new node _ list ( el )
	el . get _ child _ elements ( )
	el . get _ child _ nodes ( el )

seq2tree:
	Cal ( Nm ( el ) , Nm ( get , child , nodes ) )		(CORRECT!)
	Cal ( Nm ( el ) , Nm ( get , children ) )
	Cal ( Nm ( el ) , Nm ( get , children ) , Null ( null ) )
	ObjEx ( Cls ( node , list ) )
	Cal ( Nm ( el , queues ) , Nm ( get ) , Nm ( el ) )
------------------------------------------------------------------------------------

@Public
@Stable
public static GetQueueUserAclsInfoRequest newInstance() {
    GetQueueUserAclsInfoRequest request = Records.newRecord( !!! GetQueueUserAclsInfoRequest.class !!! );
    return request;
}

Truth:	  get _ queue _ user _ acls _ info _ request . class
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/GetQueueUserAclsInfoRequest.java :41
true_ref: ClsEx(Cls(get,queue,user,acls,info,request)) predicted at: 1, tree predicted at: 1
environment UNKs: ['records', 'acls', 'stable', 'new,record', 'get,queue,user,acls,info,request', 'new,instance']
Known subtokens to predict: [], UNK-available: ['get,queue,user,acls,info,request'], UNK-unavailable: []
hyps:
	(0.143): ClsEx(Cls(get,queue,user,acls,info,request))
	(0.044): Fld(Nm(system),Nm(out))
	(0.016): StaticCall(Nm(get,instance))
	(0.011): Fld(Nm(acls),Nm(instance))
	(0.005): StaticCall(Nm(get,acls))

seq2seq:
	new get _ queue _ user _ acls _ info _ request ( )
	get _ queue _ user _ acls _ info _ request ( )
	string . value _ of ( 0 )
	<unk> _ <unk> . class
	get _ queue _ user _ acls _ info _ request . class		(CORRECT!)


seq2tree:
	ObjEx ( Cls ( get , queue , user , acls , info , request ) )
	ClsEx ( Cls ( get , queue , user , acls , info , request ) )		(CORRECT!)
	ObjEx ( Cls ( get , queue , user , acls , info ) )
	StaticCall ( Nm ( new , instance ) )
	Cal ( Nm ( get ) , Nm ( new , instance ) )
------------------------------------------------------------------------------------

@Override
public long skip(long n) throws IOException {
    //
    if ( !!! n < 0 !!! ) {
        throw new IllegalArgumentException("negative skip length");
    }
    checkStream();
    //
    int skipped = 0;
    while (skipped < n) {
        int len = Math.min(((int) n - skipped), skipBytes.length);
        len = read(skipBytes, 0, len);
        if (len == -1) {
            eof = true;
            break;
        }
        skipped += len;
    }
    return skipped;
}

Truth:	  n < 0
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/DecompressorStream.java :177
true_ref: Ls(Nm(n),IntEx(0)) predicted at: 1, tree predicted at: 1
environment UNKs: ['skipped', 'negative', 'eof', 'io,exception', 'illegal,argument,exception', 'negative,skip,length', 'check,stream', 'skip,bytes']
Known subtokens to predict: ['n', '0'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.193): Ls(Nm(n),IntEx(0))
	(0.075): Leq(Nm(n),IntEx(0))
	(0.038): Gt(Nm(n),IntEx(0))
	(0.036): Gt(Nm(n),Fld(Nm(skip,bytes),Nm(length)))
	(0.031): Or(Ls(Nm(n),IntEx(0)),Geq(Nm(n),Fld(Nm(skip,bytes),Nm(length))))

seq2seq:
	! <unk>
	n < 0		(CORRECT!)
	! is _ <unk> ( )
	! is _ valid ( )
	is _ <unk> ( )

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

We are correct, complex example:

------------------------------------------------------------------------------------
@SuppressWarnings("unchecked")
private C findCounter(T key) {
    int i = key.ordinal();
    if (counters[i] == null) {
        counters[i] = newCounter(key);
    }
    return  !!! (C) counters[i] !!! ;
}

Truth:	  ( c ) counters [ i ]
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/FrameworkCounterGroup.java :191
true_ref: Cast(Cls(c),ArAc(Nm(counters),Nm(i))) predicted at: 1, tree predicted at: 1
environment UNKs: ['counters', 'ordinal', 'find,counter', 'suppress,warnings', 'new,counter']
Known subtokens to predict: ['c', 'i'], UNK-available: ['counters'], UNK-unavailable: []
hyps:
	(0.634): Cast(Cls(c),ArAc(Nm(counters),Nm(i)))
	(0.081): Cast(Cls(c),Nm(i))
	(0.019): Cast(Cls(c),Cal(ArAc(Nm(counters),Nm(i)),Nm(clone)))
	(0.006): Cast(Cls(c),ArAc(Nm(counters),Plus(Nm(i),IntEx(1))))
	(0.003): Cast(Cls(c),Cal(Nm(ordinal),Nm(get),ArAc(Nm(counters),Nm(i)),Nm(key)))

seq2seq:
	( c ) this
	( c ) counters [ i ]		(CORRECT!)
	counters [ i ]
	( c ) <unk> [ i ]
	cast . unchecked _ cast ( <unk> [ i ] )

seq2tree:
	Cast ( Cls ( c ) , ArAc ( Nm ( counters ) , Nm ( i ) ) )		(CORRECT!)
	Cast ( Cls ( c ) , Cal ( ArAc ( Nm ( counters ) , Nm ( i ) ) , Nm ( ordinal ) ) )
	Cast ( Cls ( c ) , Cal ( Nm ( <unk> ) , Nm ( get ) , Nm ( i ) ) )
	Cast ( Cls ( c ) , Cal ( ArAc ( Nm ( counters ) , Nm ( i ) ) , Nm ( get ) ) )
	Cast ( Cls ( c ) , Cal ( ArAc ( Nm ( counters ) , Nm ( i ) ) , Nm ( value ) ) )
------------------------------------------------------------------------------------

public static Map<String, String> convertToString(Map<CharSequence, CharSequence> env) {
    Map<String, String> stringMap = new HashMap<String, String>();
    for (Entry<CharSequence, CharSequence> entry : env.entrySet()) {
        stringMap.put( !!! entry.getKey().toString() !!! , entry.getValue().toString());
    }
    return stringMap;
}

Truth:	  entry . get _ key ( ) . to _ string ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/ConverterUtils.java :94
true_ref: Cal(Cal(Nm(entry),Nm(get,key)),Nm(to,string)) predicted at: 1, tree predicted at: 1
environment UNKs: ['env', 'string,map', 'to,string', 'get,value', 'entry,set', 'char,sequence', 'convert,to,string', 'hash,map']
Known subtokens to predict: ['key', 'entry', 'get'], UNK-available: ['to,string'], UNK-unavailable: []
hyps:
	(0.358): Cal(Cal(Nm(entry),Nm(get,key)),Nm(to,string))
	(0.341): Cal(Nm(entry),Nm(get,key))
	(0.036): Cal(Cal(Nm(entry),Nm(get,key)),Nm(to,lower,case))
	(0.018): Cal(Cal(Nm(entry),Nm(get,key)),Nm(convert,to,string))
	(0.017): Cal(Cal(Nm(entry),Nm(get,key)),Nm(get,name))

seq2seq:
	entry . get _ key ( )
	entry . get _ key ( ) . to _ string ( )		(CORRECT!)
	entry . get _ key ( ) . get _ name ( )
	entry . get _ key ( ) . as _ string ( )
	entry . get _ key ( ) . name ( )
------------------------------------------------------------------------------------

static LogRecordType intern(String typeName) {
    LogRecordType result =  !!! internees.get(typeName) !!! ;
    if (result == null) {
        result = new LogRecordType(typeName);
        internees.put(typeName, result);
    }
    return result;
}

Truth:	  internees . get ( type _ name )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/LogRecordType.java :41
true_ref: Cal(Nm(internees),Nm(get),Nm(type,name)) predicted at: 1, tree predicted at: 1
environment UNKs: ['intern', 'internees', 'log,record,type', 'type,name']
Known subtokens to predict: ['get'], UNK-available: ['type,name', 'internees'], UNK-unavailable: []
hyps:
	(0.678): Cal(Nm(internees),Nm(get),Nm(type,name))
	(0.066): StaticCall(Nm(get),Nm(type,name))
	(0.006): Cal(Nm(internees),Nm(intern),Nm(type,name))
	(0.006): StaticCall(Nm(intern),Nm(type,name))
	(0.005): Cal(Fld(This(this),Nm(log,record,type)),Nm(get),Nm(type,name))

seq2seq:
	internees . get ( type _ name )		(CORRECT!)
	<unk> . get ( type _ name )
	get ( type _ name )
	internees . get ( type _ name ) . get ( )
	map _ record _ internees . get ( type _ name )
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

Both mistaken, we are tree-correct
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

Both correct:

public byte[] readRawBytes(int code) throws IOException {
    int length = in.readInt();
    byte[] bytes = new byte[5 + length];
    bytes[0] = (byte) code;
    bytes[1] = (byte) (0xff & (length >> 24));
    bytes[2] = (byte) (0xff & (length >> 16));
     !!! bytes[3] !!!  = (byte) (0xff & (length >> 8));
    bytes[4] = (byte) (0xff & length);
    in.readFully(bytes, 5, length);
    return bytes;
}

Truth:	  bytes [ 3 ]
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/TypedBytesInput.java :216
true_ref: ArAc(Nm(bytes),IntEx(3)) predicted at: 1, tree predicted at: 1
environment UNKs: ['xff', '5', 'fully', '8', '24', '16', 'io,exception', 'read,raw,bytes', 'read,fully']
Known subtokens to predict: ['3', 'bytes'], UNK-available: [], UNK-unavailable: []
hyps:
	(0.972): ArAc(Nm(bytes),IntEx(3))
	(0.000): Enc(BinAnd(Nm(length),IntEx(x,f)))
	(0.000): ArAc(Nm(bytes),Plus(Nm(length),IntEx(3)))
	(0.000): ArAc(Nm(bytes),IntEx(5))
	(0.000): Enc(BinAnd(Nm(length),IntEx(x)))

seq2seq:
	bytes [ 3 ]		(CORRECT!)
	bytes [ 5 ]
	bytes [ 4 ]
	bytes [ 1 ]
	bytes [ 2 ]

	ArAc ( Nm ( bytes ) , IntEx ( 3 ) )		(CORRECT!)
	ArAc ( Nm ( bytes ) , IntEx ( 1 ) )
	ArAc ( Nm ( bytes ) , IntEx ( 5 ) )
	ArAc ( Nm ( bytes ) , IntEx ( 4 ) )
	ArAc ( Nm ( bytes ) , <unk> ( IntEx ( 3 ) ) )

------------------------------------------------------------------------------------

private static LinkedHashSet<InetAddress> getSubinterfaceInetAddrs(NetworkInterface nif) {
    LinkedHashSet<InetAddress> addrs = new LinkedHashSet<InetAddress>();
    Enumeration<NetworkInterface> subNifs = nif.getSubInterfaces();
    while ( !!! subNifs.hasMoreElements() !!! ) {
        NetworkInterface subNif = subNifs.nextElement();
        addrs.addAll(Collections.list(subNif.getInetAddresses()));
    }
    return addrs;
}

Truth:	  sub _ nifs . has _ more _ elements ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/DNS.java :132
true_ref: Cal(Nm(sub,nifs),Nm(has,more,elements)) predicted at: 1, tree predicted at: 1
environment UNKs: ['subinterface', 'addrs', 'network', 'nif', 'enumeration', 'nifs', 'addresses', 'interfaces', 'get,subinterface,inet,addrs', 'network,interface', 'inet,address', 'linked,hash,set', 'add,all', 'sub,nifs', 'sub,nif', 'get,inet,addresses', 'next,element', 'get,sub,interfaces']
Known subtokens to predict: ['elements', 'more', 'has'], UNK-available: ['sub,nifs'], UNK-unavailable: []
hyps:
	(0.971): Cal(Nm(sub,nifs),Nm(has,more,elements))
	(0.027): Cal(Nm(sub,nifs),Nm(has,more,tokens))
	(0.001): Cal(Nm(sub,nifs),Nm(has,more,children))
	(0.000): Cal(Nm(sub,nifs),Nm(has,more,data,elements))
	(0.000): Cal(Nm(sub,nifs),Nm(has,more,data))

seq2seq:
	sub _ nifs . has _ more _ elements ( )		(CORRECT!)
	sub _ nifs != null
	sub _ nifs . has _ more _ tokens ( )
	nifs . has _ more _ elements ( )
	sub _ nifs . has _ next ( )
seq2tree:
	Cal ( Nm ( sub , nifs ) , Nm ( has , more , elements ) )		(CORRECT!)
	Not ( Cal ( Nm ( sub , nifs ) , Nm ( has , more , elements ) ) )
	Cal ( Nm ( sub , nifs ) , Nm ( has , next ) )
	<unk> ( Cal ( Nm ( sub , nifs ) , Nm ( has , more , elements ) ) , Not ( Nm ( <unk> ) ) )
	<unk> ( Cal ( Nm ( sub , nifs ) , Nm ( has , more , elements ) ) , Not ( Nm ( <unk> , <unk> ) ) )
------------------------------------------------------------------------------------

Tree Correct:

@Override
public int compare(FileSummary.Section s1, FileSummary.Section s2) {
    SectionName n1 =  !!! SectionName.fromString(s1.getName()) !!! ;
    SectionName n2 = SectionName.fromString(s2.getName());
    if (n1 == null) {
        return n2 == null ? 0 : -1;
    } else if (n2 == null) {
        return -1;
    } else {
        return n1.ordinal() - n2.ordinal();
    }
}

Truth:	  section _ name . from _ string ( s _ 1 . get _ name ( ) )

file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/FSImageFormatProtobuf.java :197
true_ref: Cal(Nm(section,name),Nm(from,string),Cal(Nm(s),Nm(get,name))) predicted at: 3, tree predicted at: 1
environment UNKs: ['ordinal', 'section,name', 'file,summary', 'from,string', 'get,name']
Known subtokens to predict: ['s'], UNK-available: ['from,string', 'section,name', 'get,name'], UNK-unavailable: []
hyps: 
	(0.221): Cal(Nm(s),Nm(from,string),Cal(Nm(s),Nm(get,name)))
	(0.118): Cal(Nm(section,name),Nm(from,string),Cal(Nm(s),Nm(get,name)),BoolEx(false))
	(0.100): Cal(Nm(section,name),Nm(from,string),Cal(Nm(s),Nm(get,name)))
	(0.090): Cal(Nm(s),Nm(from,string),Cal(Nm(s),Nm(get,name)),BoolEx(false))
	(0.074): Cal(Nm(s),Nm(from,string),Cal(Nm(s),Nm(get,name)),BoolEx(true))

seq2seq:
	section _ name . from _ string ( s _ 1 . get _ name ( ) )		(CORRECT!)
	section _ name . from _ string ( s _ 2 . get _ name ( ) )
	s _ 1 . get _ name ( )
	section _ name . get _ name ( )
	section _ name . from _ string ( section _ name . from _ string ( s _ 2 ) )
------------------------------------------------------------------------------------

public AclStatus getAclStatus(Path path) throws IOException {
    throw new UnsupportedOperationException( !!! getClass().getSimpleName() !!!  + " doesn't support getAclStatus");
}

Truth:	  get _ class ( ) . get _ simple _ name ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/FileSystem.java :2428
true_ref: Cal(StaticCall(Nm(get,class)),Nm(get,simple,name)) predicted at: 4, tree predicted at: 1
environment UNKs: ['doesnt', 'acl', 'doesnt,support,get,acl,status', 'unsupported,operation,exception', 'io,exception', 'get,acl,status', 'acl,status']
Known subtokens to predict: ['name', 'simple', 'class', 'get'], UNK-available: [], UNK-unavailable: []
hyps: 
	(0.661): Cal(StaticCall(Nm(get,class)),Nm(get,name))
	(0.099): StaticCall(Nm(get,class))
	(0.029): Cal(Cal(This(this),Nm(get,class)),Nm(get,name))
	(0.028): Cal(StaticCall(Nm(get,class)),Nm(get,simple,name))
	(0.022): StaticCall(Nm(get,error,code))

seq2seq:
	get _ class ( ) . get _ name ( )
	get _ class ( ) . get _ simple _ name ( )		(CORRECT!)
	get _ class ( ) . get _ canonical _ name ( )
	" _ path _ <unk> not <unk> in " + get _ path ( )
	" _ path _ <unk> not <unk> in " + get _ path ( path )
------------------------------------------------------------------------------------

static void checkPermissionForApi(FSPermissionChecker pc, XAttr xAttr, boolean isRawPath) throws AccessControlException {
    final boolean isSuperUser = pc.isSuperUser();
    if (xAttr.getNameSpace() == XAttr.NameSpace.USER || (xAttr.getNameSpace() == XAttr.NameSpace.TRUSTED && isSuperUser)) {
        return;
    }
    if (xAttr.getNameSpace() ==  !!! XAttr.NameSpace.RAW !!!  && isRawPath && isSuperUser) {
        return;
    }
    throw new AccessControlException("User doesn't have permission for xattr: " + XAttrHelper.getPrefixName(xAttr));
}

Truth:	  x _ attr . name _ space . raw
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/XAttrPermissionFilter.java :69
true_ref: Fld(Fld(Nm(x,attr),Nm(name,space)),Nm(raw)) predicted at: 3, tree predicted at: 1
environment UNKs: ['api', 'pc', 'fs', 'doesnt', 'have', 'trusted', 'x,attr', 'get,name,space', 'is,raw,path', 'is,super,user', 'access,control,exception', 'check,permission,for,api', 'fs,permission,checker', 'user,doesnt,have,permission,for,xattr', 'get,prefix,name', 'x,attr,helper', 'name,space']
Known subtokens to predict: ['raw'], UNK-available: ['name,space', 'x,attr'], UNK-unavailable: []
hyps: 
	(0.046): Fld(Fld(Nm(x,attr),Nm(name,space)),Nm(api))
	(0.039): Fld(Fld(Nm(x,attr),Nm(name,space)),Nm(trusted))
	(0.035): Fld(Fld(Nm(x,attr),Nm(name,space)),Nm(raw))
	(0.023): Fld(Fld(Nm(x,attr),Nm(name,space)),Nm(none))
	(0.011): Fld(Fld(Nm(x,attr),Nm(name,space)),Nm(not,trusted))

seq2seq:
	x _ attr . get _ name _ space ( )
	x _ attr . name _ space
	x _ attr . name _ <unk>
	x _ attr . get _ name _ identifier ( )
	x _ attr . name _ space . <unk>
------------------------------------------------------------------------------------

public void createManifestForPartUpload(Path path) throws IOException {
    String pathString = toObjectPath(path).toString();
    if (!pathString.endsWith("/")) {
        pathString = pathString.concat("/");
    }
    if ( !!! pathString.startsWith("/") !!! ) {
        pathString = pathString.substring(1);
    }
    swiftRestClient.upload(toObjectPath(path), new ByteArrayInputStream(new byte[0]), 0, new Header(SwiftProtocolConstants.X_OBJECT_MANIFEST, pathString));
}

Truth:	  path _ string . starts _ with ( " _ /" )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/SwiftNativeFileSystemStore.java :162
true_ref: Cal(Nm(path,string),Nm(starts,with),StrEx(/)) predicted at: 3, tree predicted at: 1
environment UNKs: ['manifest', 'upload', 'swift', 'rest', 'concat', 'io,exception', 'create,manifest,for,part,upload', 'swift,rest,client', 'path,string', 'to,object,path', 'byte,array,input,stream', 'ends,with', 'x,object,manifest', 'to,string', 'swift,protocol,constants']
Known subtokens to predict: ['starts', 'with', '/'], UNK-available: ['path,string'], UNK-unavailable: []
hyps: 
	(0.116): Cal(Nm(path,string),Nm(ends,with),StrEx(/))
	(0.049): Cal(Nm(path,string),Nm(ends,with),StrEx(.))
	(0.043): Cal(Nm(path,string),Nm(starts,with),StrEx(/))
	(0.032): Cal(Nm(path,string),Nm(ends,with),StrEx(:))
	(0.012): Cal(Nm(path,string),Nm(starts,with),StrEx(.))

seq2seq:
	path _ string . starts _ with ( " _ <unk> )
	path _ string . ends _ with ( " _ <unk> )
	path _ string . starts _ with ( " _ /" )		(CORRECT!)
	! path _ string . starts _ with ( " _ <unk> )
	! path _ string . ends _ with ( " _ <unk> )
------------------------------------------------------------------------------------

@Override
public int compareTo(IntPair o) {
    if ( !!! first != o.first !!! ) {
        return first < o.first ? -1 : 1;
    } else if (second != o.second) {
        return second < o.second ? -1 : 1;
    } else {
        return 0;
    }
}

Truth:	  first != o . first
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/SecondarySort.java :120
true_ref: Neq(Nm(first),Fld(Nm(o),Nm(first))) predicted at: 2, tree predicted at: 1
environment UNKs: ['compare,to', 'int,pair']
Known subtokens to predict: ['o', 'first'], UNK-available: [], UNK-unavailable: []
hyps: 
	(0.268): Neq(Nm(o),Fld(Nm(o),Nm(first)))
	(0.211): Neq(Nm(first),Fld(Nm(o),Nm(first)))
	(0.176): Eq(Nm(second),Fld(Nm(o),Nm(second)))
	(0.035): And(Neq(Nm(o),Null(null)),Neq(Nm(o),Null(null)))
	(0.015): Eq(Nm(o),Fld(Nm(o),Nm(first)))

seq2seq:
	second != o . first
	first != o . first		(CORRECT!)
	o != null
	o . first != null
	second != o . second
------------------------------------------------------------------------------------

private void safeDelete(CloudBlockBlobWrapper blob) throws StorageException {
    OperationContext operationContext = getInstrumentedContext();
    try {
        blob.delete(operationContext);
    } catch (StorageException e) {
        if (e.getErrorCode() != null && e.getErrorCode().equals("BlobNotFound") &&  !!! operationContext.getRequestResults().size() !!!  > 1 
        	&& operationContext.getRequestResults().get(0).getException() != null) {
            if (LOG.isDebugEnabled()) {
                LOG.debug("Swallowing delete exception on retry: " + e.getMessage());
            }
            return;
        } else {
            throw e;
        }
    }
}

Truth:	  operation _ context . get _ request _ results ( ) . size ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/AzureNativeFileSystemStore.java :2071
true_ref: Cal(Cal(Nm(operation,context),Nm(get,request,results)),Nm(size)) predicted at: 3, tree predicted at: 1
environment UNKs: ['blob', 'cloud', 'swallowing', 'retry', 'instrumented', 'blob,not,found', 'get,exception', 'get,error,code', 'storage,exception', 'get,request,results', 'operation,context', 'is,debug,enabled', 'safe,delete', 'cloud,block,blob,wrapper', 'swallowing,delete,exception,on,retry', 'get,message', 'get,instrumented,context']
Known subtokens to predict: ['size'], UNK-available: ['operation,context', 'get,request,results'], UNK-unavailable: []
hyps: 
	(0.392): Cal(Cal(Nm(e),Nm(get,request,results)),Nm(size))
	(0.124): Cal(Cal(Nm(e),Nm(get,error,code)),Nm(length))
	(0.036): Cal(Cal(Nm(operation,context),Nm(get,request,results)),Nm(size))
	(0.035): Cal(Cal(Nm(e),Nm(get,error,code)),Nm(size))
	(0.027): Cal(Cal(Nm(e),Nm(get,exception)),Nm(length))

seq2seq:
	operation _ context . get _ request _ results ( ) . size ( )		(CORRECT!)
	e . get _ request _ results ( ) . size ( )
	e . get _ error _ code ( ) . get _ exception _ count ( )
	e . get _ error _ code ( ) . length
	operation _ context . get _ error _ code ( ) . get _ exception _ count ( )
------------------------------------------------------------------------------------

static String getHomeDir(String name) {
    String homeDir = HOME_DIR_TL.get();
    if (homeDir == null) {
        String sysProp = name + HOME_DIR;
        homeDir =  !!! System.getProperty(sysProp) !!! ;
        if (homeDir == null) {
            throw new IllegalArgumentException(MessageFormat.format("System property [{0}] not defined", sysProp));
        }
    }
    return homeDir;
}

Truth:	  system . get _ property ( sys _ prop )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/ServerWebApp.java :120
true_ref: Cal(Nm(system),Nm(get,property),Nm(sys,prop)) predicted at: 2, tree predicted at: 1
environment UNKs: ['sys', '[{', '}]', 'tl', 'home,dir', 'sys,prop', 'get,home,dir', 'illegal,argument,exception', 'system,property,[{,}],not,defined', 'message,format', 'home,dir,tl']
Known subtokens to predict: ['system', 'property', 'get'], UNK-available: ['sys,prop'], UNK-unavailable: []
hyps: 
	(0.148): Cal(Nm(home,dir,tl),Nm(get),Nm(sys,prop))
	(0.056): Cal(Nm(system),Nm(get,property),Nm(sys,prop))
	(0.039): ObjEx(Cls(file),Nm(sys,prop))
	(0.024): Cal(Nm(system,properties),Nm(get),Nm(sys,prop))
	(0.021): StaticCall(Nm(find,home,dir),Nm(sys,prop))

seq2seq:
	home _ dir _ tl . get ( sys _ prop )
	system . get _ property ( sys _ prop )		(CORRECT!)
	<unk> _ prop . trim ( )
	get _ home _ dir ( sys _ prop )
	home _ dir _ tl . get ( home _ dir )
------------------------------------------------------------------------------------

public static Path[] stringToPath(String[] str) {
    if (str == null) {
        return null;
    }
    Path[] p = new Path[str.length];
    for (int i = 0;  !!! i < str.length !!! ; i++) {
        p[i] = new Path(str[i]);
    }
    return p;
}

Truth:	  i < str . length
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/StringUtils.java :243
true_ref: Ls(Nm(i),Fld(Nm(str),Nm(length))) predicted at: 2, tree predicted at: 1
environment UNKs: ['string,to,path']
Known subtokens to predict: ['i', 'length', 'str'], UNK-available: [], UNK-unavailable: []
hyps: 
	(0.644): Ls(Nm(i),Fld(Nm(p),Nm(length)))
	(0.347): Ls(Nm(i),Fld(Nm(str),Nm(length)))
	(0.000): Ls(Nm(i),Fld(Nm(s),Nm(length)))
	(0.000): Ls(Nm(i),Fld(Nm(data),Nm(length)))
	(0.000): Ls(Nm(i),Minus(Fld(Nm(p),Nm(length)),IntEx(1)))

seq2seq:
	i < str . length		(CORRECT!)
	i < p . length
	i < str . length ( )
	i <= str . length
	i < str . length - 1
------------------------------------------------------------------------------------

private void checkMetadata(S3Object object) throws S3FileSystemException, S3ServiceException {
    String name = (String) object.getMetadata(FILE_SYSTEM_NAME);
    if (!FILE_SYSTEM_VALUE.equals(name)) {
        throw new S3FileSystemException("Not a Hadoop S3 file.");
    }
    String type = (String) object.getMetadata(FILE_SYSTEM_TYPE_NAME);
    if (!FILE_SYSTEM_TYPE_VALUE.equals(type)) {
        throw new S3FileSystemException("Not a block file.");
    }
    String dataVersion = (String) object.getMetadata(FILE_SYSTEM_VERSION_NAME);
    if (! !!! FILE_SYSTEM_VERSION_VALUE.equals(dataVersion) !!! ) {
        throw new VersionMismatchException(FILE_SYSTEM_VERSION_VALUE, dataVersion);
    }
}

Truth:	  file _ system _ version _ value . equals ( data _ version )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/Jets3tFileSystemStore.java :219
true_ref: Cal(Nm(file,system,version,value),Nm(equals),Nm(data,version)) predicted at: 3, tree predicted at: 1
environment UNKs: ['mismatch', 'check,metadata', 's,file,system,exception', 's,service,exception', 'data,version', 'file,system,version,value', 's,object', 'version,mismatch,exception', 'file,system,type,value', 'not,a,block,file', 'get,metadata', 'file,system,version,name', 'file,system,type,name']
Known subtokens to predict: ['equals'], UNK-available: ['file,system,version,value', 'data,version'], UNK-unavailable: []
hyps: 
	(0.143): Cal(Nm(data,version),Nm(equals),Nm(data,version))
	(0.048): Cal(Nm(data,version),Nm(equals),Nm(version))
	(0.028): Cal(Nm(file,system,version,value),Nm(equals),Nm(data,version))
	(0.006): Cal(Nm(data,version),Nm(starts,with),Nm(file,system,version,value))
	(0.004): Cal(Nm(data,version),Nm(starts,with),Nm(file,system,type,name))

seq2seq:
	file _ system _ type _ value . equals ( data _ version )
	file _ system _ type _ value . equals ( type )
	file _ system _ version . equals ( type )
	file _ system _ version _ value . equals ( type )
	file _ system _ version _ value . equals ( data _ version )		(CORRECT!)
------------------------------------------------------------------------------------

private void printTaskAttempts(TaskReport report) {
    if (report.getCurrentStatus() == TIPStatus.COMPLETE) {
        System.out.println(report.getSuccessfulTaskAttemptId());
    } else if ( !!! report.getCurrentStatus() == TIPStatus.RUNNING !!! ) {
        for (TaskAttemptID t : report.getRunningTaskAttemptIds()) {
            System.out.println(t);
        }
    }
}

Truth:	  report . get _ current _ status ( ) == tip _ status . running
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/CLI.java :557
true_ref: Eq(Cal(Nm(report),Nm(get,current,status)),Fld(Nm(tip,status),Nm(running))) predicted at: 2, tree predicted at: 1
environment UNKs: ['report', 'complete', 'running', 'attempt', 'attempts', 'tip', 'successful', 'get,running,task,attempt,ids', 'get,current,status', 'task,attempt,id', 'print,task,attempts', 'tip,status', 'task,report', 'get,successful,task,attempt,id']
Known subtokens to predict: [], UNK-available: ['report', 'get,current,status', 'tip,status', 'running'], UNK-unavailable: []
hyps: 
	(0.061): Eq(Cal(Nm(report),Nm(get,current,status)),Fld(Nm(tip,status),Nm(failed)))
	(0.060): Eq(Cal(Nm(report),Nm(get,current,status)),Fld(Nm(tip,status),Nm(running)))
	(0.026): Eq(Cal(Nm(report),Nm(get,current,status)),Fld(Nm(tip,status),Nm(active)))
	(0.023): Eq(Cal(Nm(report),Nm(get,current,status)),Fld(Nm(tip,status),Nm(attempts)))
	(0.014): Eq(Cal(Nm(report),Nm(get,current,status)),Fld(Nm(tip,status),Nm(not,active)))

seq2seq:
	report . get _ current _ status ( ) == tip _ status . <unk>
	report . get _ current _ status ( ) == tip _ status . complete
	report . get _ current _ status ( ) == tip _ status . running		(CORRECT!)
	report . get _ current _ status ( ) == tip _ status . not _ <unk>
	report . get _ current _ status ( ) == tip _ status . not _ complete
------------------------------------------------------------------------------------

@Override
public int compareTo(LongWritable o) {
    long thisValue = this.value;
    long thatValue = o.value;
    return (thisValue < thatValue ? -1 : ( !!! thisValue == thatValue ? 0 : 1 !!! ));
}

Truth:	  this _ value == that _ value ? 0 : 1
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/LongWritable.java :74
true_ref: Cond(Eq(Nm(this,value),Nm(that,value)),IntEx(0),IntEx(1)) predicted at: 2, tree predicted at: 1
environment UNKs: ['writable', 'that,value', 'this,value', 'compare,to', 'long,writable']
Known subtokens to predict: ['1', '0'], UNK-available: ['this,value', 'that,value'], UNK-unavailable: []
hyps: 
	(0.163): Cond(Eq(Nm(this,value),Nm(this,value)),IntEx(0),IntEx(1))
	(0.110): Cond(Eq(Nm(this,value),Nm(that,value)),IntEx(0),IntEx(1))
	(0.095): Cond(Eq(Nm(this,value),Nm(value)),IntEx(0),IntEx(1))
	(0.066): Cond(Gt(Nm(this,value),Nm(that,value)),IntEx(0),IntEx(1))
	(0.061): Cond(Enc(Eq(Nm(this,value),Nm(this,value))),IntEx(0),IntEx(1))

seq2seq:
	that _ value > > that _ value
	that _ value > that _ value ? 1 : 0
	that _ value > that _ value
	this _ value > that _ value ? 1 : 0
	that _ value == that _ value ? 1 : 0
------------------------------------------------------------------------------------

private void mergeLocalToBuilder() {
    if (this.containerStatuses != null) {
        addNMContainerStatusesToProto();
    }
    if ( !!! this.runningApplications != null !!! ) {
        addRunningApplicationsToProto();
    }
    if (this.resource != null) {
        builder.setResource(convertToProtoFormat(this.resource));
    }
    if (this.nodeId != null) {
        builder.setNodeId(convertToProtoFormat(this.nodeId));
    }
}

Truth:	  this . running _ applications != null
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/RegisterNodeManagerRequestPBImpl.java :80
true_ref: Neq(Fld(This(this),Nm(running,applications)),Null(null)) predicted at: 2, tree predicted at: 1
environment UNKs: ['running', 'applications', 'proto', 'statuses', 'nm', 'merge,local,to,builder', 'add,running,applications,to,proto', 'container,statuses', 'node,id', 'set,node,id', 'set,resource', 'add,nm,container,statuses,to,proto', 'convert,to,proto,format']
Known subtokens to predict: ['null', 'this'], UNK-available: ['running', 'applications'], UNK-unavailable: []
hyps: 
	(0.138): Neq(Fld(This(this),Nm(running)),Null(null))
	(0.100): Neq(Fld(This(this),Nm(running,applications)),Null(null))
	(0.036): Neq(Fld(This(this),Nm(running,proto)),Null(null))
	(0.023): Fld(This(this),Nm(running,applications))
	(0.019): Fld(This(this),Nm(add,running,applications,to,proto))

seq2seq:
	this . running _ applications != null		(CORRECT!)
	this . resource != null
	this . applications _ applications != null
	this . proto _ applications != null
	this . running _ to _ proto != null
------------------------------------------------------------------------------------
public float getProgress() {
  this.readLock.lock();
  try {
   if (this.currentAttempt != null) {
     return |\greenbox{this.currentAttempt.getProgress()}|;
   }
   return 0;
  } finally {
    this.readLock.unlock();
  }
}

Truth:	  this . current _ attempt . get _ progress ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/RMAppImpl.java :417
true_ref: Cal(Fld(This(this),Nm(current,attempt)),Nm(get,progress)) predicted at: 5, tree predicted at: 1
environment UNKs: ['attempt', 'unlock', 'current,attempt', 'get,progress', 'read,lock']
Known subtokens to predict: ['this'], UNK-available: ['current,attempt', 'get,progress'], UNK-unavailable: []
hyps: 
	(0.313): Cal(Fld(This(this),Nm(current,attempt)),Nm(get,count))
	(0.306): Neg(IntEx(1))
	(0.015): Cal(Fld(This(this),Nm(current,attempt)),Nm(get))
	(0.012): Cal(Fld(This(this),Nm(current,attempt)),Nm(get,time))
	(0.009): Cal(Fld(This(this),Nm(current,attempt)),Nm(get,progress))

seq2seq:
	this . current _ attempt . get _ progress ( )		(CORRECT!)
	this . current _ attempt . float _ value ( )
	this . current _ attempt . get _ float ( )
	this . current _ attempt . get ( )
	this . current _ attempt . get _ time ( )
------------------------------------------------------------------------------------

public byte[] readRawByte() throws IOException {
    byte[] bytes =  !!! new byte[2] !!! ;
    bytes[0] = (byte) Type.BYTE.code;
    in.readFully(bytes, 1, 1);
    return bytes;
}

Truth:	  new byte [ 2 ]
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/TypedBytesInput.java :246
true_ref: ArCr(ArCrLvl(IntEx(2)),Prim(byte)) predicted at: 4, tree predicted at: 1
environment UNKs: ['fully', 'io,exception', 'read,raw,byte', 'read,fully']
Known subtokens to predict: ['byte', '2'], UNK-available: [], UNK-unavailable: []
hyps: 
	(0.090): ArCr(ArCrLvl(IntEx(1)),Prim(byte))
	(0.078): ArCr(ArCrLvl(IntEx(3)),Prim(byte))
	(0.055): ArCr(ArCrLvl(IntEx(4)),Prim(byte))
	(0.034): ArCr(ArCrLvl(IntEx(2)),Prim(byte))
	(0.007): ArCr(ArCrLvl(Fld(Nm(type),Nm(length))),Prim(byte))

seq2seq:
	new byte [ <unk> ]
	new byte [ 1 ]
	read _ raw _ byte ( )
	new byte [ type . byte _ array ( ) ]
	new byte [ in . read _ byte ( ) ]

------------------------------------------------------------------------------------
public static synchronized void addDefaultResource(String name) {
    if (! !!! defaultResources.contains(name) !!! ) {
        defaultResources.add(name);
        for (Configuration conf : REGISTRY.keySet()) {
            if (conf.loadDefaults) {
                conf.reloadConfiguration();
            }
        }
    }
}

Truth:	  default _ resources . contains ( name )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/Configuration.java :695
true_ref: Cal(Nm(default,resources),Nm(contains),Nm(name)) predicted at: 2, tree predicted at: 1
environment UNKs: ['conf', 'defaults', 'reload', 'add,default,resource', 'key,set', 'default,resources', 'load,defaults', 'reload,configuration']
Known subtokens to predict: ['contains', 'name'], UNK-available: ['default,resources'], UNK-unavailable: []
hyps: 
	(0.731): Cal(Nm(default,resources),Nm(contains,key),Nm(name))
	(0.068): Cal(Nm(default,resources),Nm(contains),Nm(name))
	(0.014): Cal(Nm(default,resources),Nm(add),Nm(name))
	(0.003): Cal(Fld(Nm(instance),Nm(load,defaults)),Nm(contains,key),Nm(name))
	(0.002): Cal(Cal(Nm(thread),Nm(current,thread)),Nm(contains,key),Nm(name))

seq2seq:
	default _ resources . contains _ key ( name )
	default _ resources . contains ( name )		(CORRECT!)
	registry . is ( " _ ide _ <unk> )
	registry . contains _ key ( name )
	<unk> . contains _ key ( name )


------------------------------------------------------------------------------------
private List<INode> initChildren() {
  if (children == null) {
    final ChildrenDiff combined = new ChildrenDiff();
    for (DirectoryDiff d = DirectoryDiff.this; d != null;  !!! d = d.getPosterior() !!! ) {
      combined.combinePosterior(d.diff, null);
    }
    children = combined.apply2Current(ReadOnlyList.Util.asList(currentDir.getChildrenList(Snapshot.CURRENT_STATE_ID)));
  }
  return children;
}

Truth:	  d = d . get _ posterior ( )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/DirectoryWithSnapshotFeature.java :237
true_ref: As(Nm(d),Cal(Nm(d),Nm(get,posterior))) predicted at: 5, tree predicted at: 1
environment UNKs: ['combine', 'posterior', 'combined', 'directory,diff', 'combine,posterior', 'children,diff', 'apply,current', 'init,children', 'i,node', 'as,list', 'current,dir', 'get,children,list', 'read,only,list', 'current,state,id']
Known subtokens to predict: ['d', 'get'], UNK-available: ['posterior'], UNK-unavailable: []
hyps: 
	(0.188): As(Nm(d),Cal(Nm(d),Nm(get,parent)))
	(0.149): As(Nm(d),Cal(Nm(d),Nm(get,children,list)))
	(0.045): As(Nm(d),Nm(d))
	(0.025): As(Nm(d),Nm(combined))
	(0.018): As(Nm(d),Cal(Nm(d),Nm(get,posterior)))

seq2seq:
	d = d . <unk>
	d = d . diff
	d = d . get _ children ( )
	d = d . current _ dir
	d = d . current _ state _ id
------------------------------------------------------------------------------------

public static int locationToDepth(String location) {
  String normalizedLocation = normalize(location);
  int length = normalizedLocation.length();
  int depth = 0;
  for (int i = 0; i < length; i++) {
    if ( !!! normalizedLocation.charAt(i) !!!  == PATH_SEPARATOR) {
      depth++;
    }
  }
  return depth;
}

Truth:	  normalized _ location . char _ at ( i )
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/NodeBase.java :176
true_ref: Cal(Nm(normalized,location),Nm(char,at),Nm(i)) predicted at: 2, tree predicted at: 1
environment UNKs: ['depth', 'normalized', 'normalize', 'path,separator', 'location,to,depth', 'normalized,location']
Known subtokens to predict: ['i', 'at', 'char'], UNK-available: ['normalized,location'], UNK-unavailable: []
hyps: 
	(0.731): Cal(Nm(location),Nm(char,at),Nm(i))
	(0.048): Cal(Nm(normalized,location),Nm(char,at),Nm(i))
	(0.022): ArAc(Nm(my,data),Nm(i))
	(0.003): Cal(Nm(location),Nm(char,at),PosInc(Nm(normalized)))
	(0.002): Cal(Nm(location),Nm(char,at),PosInc(Nm(offset)))

seq2seq:
	normalized _ location . char _ at ( i )		(CORRECT!)
	normalized _ location [ i ]
	location . char _ at ( i )
	normalized [ i ]
	character . to _ <unk> _ case ( normalized _ location )
------------------------------------------------------------------------------------


public static void setOwner(File file, String username, String groupname) throws IOException {
    if (username == null && groupname == null) {
        throw new IOException("username == null && groupname == null");
    }
    String arg = ( !!! username == null ? "" : username !!! ) + (groupname == null ? "" : ":" + groupname);
    String[] cmd = Shell.getSetOwnerCommand(arg);
    execCommand(file, cmd);
}

Truth:	  username == null ? " _ " : username
file:///home/urialon/Allamanis-dataset/java-small/test/hadoop/FileUtil.java :896
true_ref: Cond(Eq(Nm(username),Null(null)),StrEx(BLANK),Nm(username)) predicted at: 1, tree predicted at: 1
environment UNKs: ['groupname', 'exec', 'username', 'cmd', '==', '&&', 'shell', 'io,exception', 'set,owner', 'exec,command', 'username,==,null,&&,groupname,==,null', 'get,set,owner,command']
Known subtokens to predict: ['null', 'BLANK'], UNK-available: ['username'], UNK-unavailable: []
hyps: 
	(0.276): Cond(Eq(Nm(username),Null(null)),StrEx(BLANK),Nm(username))
	(0.051): Cond(Neq(Nm(file),Null(null)),Nm(file),StrEx(BLANK))
	(0.033): Cond(Neq(Nm(username),Null(null)),Nm(username),StrEx(BLANK))
	(0.030): Cond(Eq(Nm(groupname),Null(null)),StrEx(BLANK),Nm(username))
	(0.029): Cond(Eq(Nm(groupname),Null(null)),StrEx(BLANK),Nm(groupname))

seq2seq:
	username == null ? " _ " : groupname
	username == null ? " _ " : username		(CORRECT!)
	username == null ? " _ " : " _ "
	file . get _ name ( ) + " _ <unk>
	file . get _ name ( ) + " _ "
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------